package servlet.ins;

package ..deTemp.1739856303671;

import bean.DataBlackBean;
import bean.DataInsBean;
import bean.DataPostBean;
import bean.DataPostList1Bean;
import bean.DataPostListBean;
import bean.DataUserBean;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.servlet.http.HttpSession;
import jdbc.Jdbc;
import org.apache.http.util.TextUtils;
import org.json.JSONArray;
import org.json.JSONObject;
import tools.NativePlace;
import tools.SysTools;
import tools.Tools;

public class DataParse {
  private DataUserBean mb = null;
  
  public DataParse(DataUserBean mb) {
    this.mb = mb;
  }
  
  private ArrayList getRowList(boolean isAddSn, String json, int row, String[] head) {
    ArrayList<ArrayList<Integer>> rowList = new ArrayList();
    try {
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        if (isAddSn)
          tmp_row.add(Integer.valueOf(i)); 
        for (int j = 0; j < head.length; j++)
          tmp_row.add(tmp1.get(String.valueOf(head[j]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return rowList;
  }
  
  private int[] getResultSum(String certno, ArrayList<ArrayList> result_list) {
    int[] back = new int[2];
    back[0] = 0;
    back[1] = 0;
    for (int j = 0; j < result_list.size(); j++) {
      ArrayList<String> bean = result_list.get(j);
      String tmp_certno = bean.get(0);
      String tmp_part = bean.get(1);
      if (certno.equals(tmp_certno)) {
        back[0] = back[0] + 1;
        back[1] = back[1] + Tools.getIntExcep(tmp_part);
      } 
    } 
    return back;
  }
  
  private boolean isTake(String certno, ArrayList<String> result_list) {
    for (int j = 0; j < result_list.size(); j++) {
      String certnox = result_list.get(j);
      if (certno.equals(certnox))
        return true; 
    } 
    return false;
  }
  
  public String readExcel_chengren(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      ArrayList<ArrayList> rowList = getRowList(true, json, row, head);
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      int partx = 0;
      String price = this.mb.getPriceNew(did, jdbc);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int i = 0; i < rowList.size(); i++) {
        ArrayList<String> tmp_list = rowList.get(i);
        String error = "", warning = "";
        String name = trim_all(tmp_list.get(4));
        String certno = tmp_list.get(6);
        String keepername = trim_all(tmp_list.get(0));
        String keepercertno = tmp_list.get(2);
        int part1 = Tools.getIntExcep(tmp_list.get(9));
        String guanxi = tmp_list.get(3);
        String birthday1 = tmp_list.get(7);
        String sex1 = tmp_list.get(8);
        partx += part1;
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        if (Tools.isCard(certno)) {
          Map tmp_map = Tools.getBirthday(certno);
          String tmp_sex = (String)tmp_map.get("sexCode");
          String tmp_birth = (String)tmp_map.get("birthday");
          if (!birthday1.equals(tmp_birth)) {
            tmp_list.set(7, tmp_birth);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex)) {
            tmp_list.set(8, tmp_sex);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = String.valueOf(warning) + "被保人性别错误";
          } 
        } 
        int[] el1 = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!certno.equals(keepercertno)) {
          error = "投保人与被保人的证件号姓名不一致";
        } else if (!name.equals(keepername)) {
          error = "投保人与被保人的姓名不一致";
        } else if (!Tools.checkAge(keepercertno, 18, 59)) {
          error = "投保人年龄必须 18-59 周岁";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(i, certno, rowList, 6)) {
          error = "被保人在一份数据中不允许重复";
        } else if (!guanxi.equals("本人")) {
          error = "与被保险人关系不是本人";
        } else if (part1 < 1 || part1 > 3) {
          error = "投保份数必须是1,2,3";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did=" + did + " and c3='" + keepercertno + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "投保人一天内不允许提交2次";
        } else {
          int sum2 = Tools.getIntExcep(jdbc.selectOnlyField("select sum(c10) from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') " + 
                "and did=" + did + " and c3='" + keepercertno + "'"));
          if (part1 + sum2 > 3)
            error = "投保人已投保了" + sum2 + "份，超出投保上限（3份）"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(i, name, rowList, 4)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(i));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(String.valueOf(part1));
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(0));
        bean1.setC2(tmp_list.get(1));
        bean1.setC3(tmp_list.get(2));
        bean1.setC4(tmp_list.get(3));
        bean1.setC5(tmp_list.get(4));
        bean1.setC6(tmp_list.get(5));
        bean1.setC7(tmp_list.get(6));
        bean1.setC8(tmp_list.get(7));
        bean1.setC9(tmp_list.get(8));
        bean1.setC10(tmp_list.get(9));
        bean1.setC11(tmp_list.get(10));
        bean1.setC12(tmp_list.get(11));
        bean1.setC13(tmp_list.get(12));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(dins.getPrice());
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_dj_cr101150(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      ArrayList<ArrayList> rowList = getRowList(true, json, row, head);
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      int partx = 0;
      String price = this.mb.getPriceNew(did, jdbc);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int i = 0; i < rowList.size(); i++) {
        ArrayList<String> tmp_list = rowList.get(i);
        String error = "", warning = "";
        String name = trim_all(tmp_list.get(1));
        String certno = tmp_list.get(6);
        String typex = tmp_list.get(5);
        int part1 = Tools.getIntExcep(tmp_list.get(7));
        partx += part1;
        certno = certno.toLowerCase();
        if (Tools.isCard(certno)) {
          Map tmp_map = Tools.getBirthday(certno);
          String tmp_sex = (String)tmp_map.get("sexCode");
          String tmp_birth = (String)tmp_map.get("birthday");
          tmp_list.set(4, tmp_birth);
          tmp_list.set(2, tmp_sex.equals("女") ? "106002" : "106001");
        } 
        int[] el1 = { 1, 2, 3, 4, 5, 6, 7, 9 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (isValueRepeat(i, certno, rowList, 6)) {
          error = "被保人在一份数据中不允许重复";
        } else if (!typex.equals("120001")) {
          error = "证件类型必须是120001";
        } else if (part1 != 1) {
          error = "投保份数必须是1份";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did=" + did + " and certno='" + certno + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "被保人一天内不允许提交2次";
        } else {
          int sum2 = Tools.getIntExcep(jdbc.selectOnlyField("select flag<>'4' and sum(c7) from data_post_list where (policy_end is null or Date(policy_end)>'" + policy_end + "') and did=" + did + " and certno='" + certno + "'"));
          if (part1 + sum2 > 1)
            error = "被保人已投保了" + sum2 + "份，超出投保上限（1份）"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(i, name, rowList, 1)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(i));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(String.valueOf(part1));
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(name);
        bean1.setKeepercertno(certno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(dins.getPrice());
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_tpy_children(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      ArrayList<ArrayList> rowList = getRowList(true, json, row, head);
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      int name_min = Tools.getIntExcep(dins.getName_min());
      int name_max = Tools.getIntExcep(dins.getName_max());
      int keeper_min = Tools.getIntExcep(dins.getKeeper_min());
      int keeper_max = Tools.getIntExcep(dins.getKeeper_max());
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int i = 0; i < rowList.size(); i++) {
        ArrayList<String> tmp_list = rowList.get(i);
        String error = "", warning = "";
        String ins_name = tmp_list.get(1);
        String keepername = trim_all(tmp_list.get(2));
        String keepercertno = tmp_list.get(3);
        String name = trim_all(tmp_list.get(4));
        String certno = tmp_list.get(5);
        String fenshu = tmp_list.get(6);
        String tel = tmp_list.get(7);
        String email = tmp_list.get(8);
        String guanxi = tmp_list.get(9);
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        String guanxi_1 = "";
        if (Tools.isCard(certno) && Tools.isCard(keepercertno)) {
          Map tmp_map1 = Tools.getBirthday(keepercertno);
          Map tmp_map2 = Tools.getBirthday(certno);
          String sex1 = (String)tmp_map1.get("sexCode");
          String sex2 = (String)tmp_map2.get("sexCode");
          if (sex1.equals("男") && sex2.equals("男")) {
            guanxi_1 = "父子";
          } else if (sex1.equals("男") && sex2.equals("女")) {
            guanxi_1 = "父女";
          } else if (sex1.equals("女") && sex2.equals("男")) {
            guanxi_1 = "母子";
          } else if (sex1.equals("女") && sex2.equals("女")) {
            guanxi_1 = "母女";
          } 
        } 
        int[] el1 = { 1, 2, 3, 4, 5, 6, 9 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("太平洋少儿A款") && did.equals("52")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("太平洋少儿B款") && did.equals("53")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("太平洋少儿C款") && did.equals("54")) {
          error = "投保方案错误";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!fenshu.equals("1")) {
          error = "份数必须是1份";
        } else if (Tools.CheckStr(email) && !Tools.isEmail(email)) {
          error = "邮箱错误";
        } else if (Tools.CheckStr(tel) && !Tools.isTel(tel)) {
          error = "手机号码错误";
        } else if (!guanxi.equals(guanxi_1)) {
          error = "关系不正确，是否应为" + guanxi_1;
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(i, certno, rowList, 5)) {
          error = "被保人证件号重复，被保人限购一份";
        } else if (!isCodeNameRepeat(i, keepername, keepercertno, rowList, 2, 3)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (name.equals(keepername) || certno.equals(keepercertno)) {
          error = "投保人与被保人的姓名、证件号必须不一致";
        } else if (!Tools.checkAge(keepercertno, 18, 65)) {
          error = "投保人年龄必须18-65周岁";
        } else if (!Tools.checkAgeDay(certno, 30, 17)) {
          error = "被保人年龄必须 30天-17周岁";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and did in (" + "52,53,54" + ") and certno='" + certno + "'")) {
          error = "被保人已达到投保上限(1份)，无法继续投保";
        } else {
          String policy_end1 = jdbc.selectOnlyField("select policy_end from data_post_list where flag='3' and did in (52,53,54) and certno='" + certno + "'");
          if (Tools.CheckStr(policy_end1)) {
            int days = Tools.getDays(Tools.getCurrentDate(), policy_end1);
            int expire = Tools.getIntExcep(dins.getExpire());
            if (days - expire > 0)
              error = "被保人当前无法投保，投保仍然生效中"; 
          } 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(i, name, rowList, 4)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(i));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(dins.getPrice());
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_pa_old_all(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Object>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Object> tmp_row = new ArrayList();
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      int name_min = Tools.getIntExcep(dins.getName_min());
      int name_max = Tools.getIntExcep(dins.getName_max());
      int keeper_min = Tools.getIntExcep(dins.getKeeper_min());
      int keeper_max = Tools.getIntExcep(dins.getKeeper_max());
      String did_scope = "did=" + did;
      if (Tools.CheckStr(dins.getPart_other_ins()))
        did_scope = "did in (" + dins.getPart_other_ins() + ")"; 
      ArrayList<DataPostListBean> post_list = new ArrayList();
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String keepername = trim_all(tmp_list.get(0));
        String keepercertno = tmp_list.get(3);
        String sex1 = tmp_list.get(1);
        String birth1 = tmp_list.get(4);
        String tel = tmp_list.get(5);
        String name = trim_all(tmp_list.get(6));
        String certno = tmp_list.get(9);
        String sex2 = tmp_list.get(7);
        String birth2 = tmp_list.get(10);
        String certnotype1 = tmp_list.get(2);
        String certnotype2 = tmp_list.get(8);
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        int tmp_age1 = 0;
        if (Tools.isCard(certno)) {
          tmp_age1 = Tools.getAgex(certno);
          Map tmp_map = Tools.getBirthday(certno);
          String tmp_sex = (String)tmp_map.get("sexCode");
          String tmp_birth1 = (String)tmp_map.get("birthday_cn");
          String tmp_birth2 = (String)tmp_map.get("birthday");
          if (!birth2.equals(tmp_birth1) && !birth2.equals(tmp_birth2)) {
            tmp_list.set(10, tmp_birth2);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex2.equals(tmp_sex)) {
            tmp_list.set(8, tmp_sex);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = String.valueOf(warning) + "被保人性别错误";
          } 
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map = Tools.getBirthday(keepercertno);
          String tmp_sex = (String)tmp_map.get("sexCode");
          String tmp_birth1 = (String)tmp_map.get("birthday_cn");
          String tmp_birth2 = (String)tmp_map.get("birthday");
          if (!birth1.equals(tmp_birth1) && !birth1.equals(tmp_birth2)) {
            tmp_list.set(4, tmp_birth2);
            warning = "投保人生日错误";
          } 
          if (!sex1.equals(tmp_sex)) {
            tmp_list.set(1, tmp_sex);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = String.valueOf(warning) + "投保人性别错误";
          } 
        } 
        int[] el1 = { 
            0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 
            10 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.CheckStr(tel) || !Tools.isTel(tel)) {
          error = "手机号码错误";
        } else if (did.equals("67") && (!certno.equals(keepercertno) || !name.equals(keepername))) {
          error = "投保人与被保人必须一致";
        } else if (!Tools.checkAge(keepercertno, keeper_min, keeper_max)) {
          error = "投保人年龄必须 " + keeper_min + "-" + keeper_max + " 周岁";
        } else if (!Tools.checkAge(certno, name_min, name_max)) {
          error = "被保人年龄必须 " + name_min + "-" + name_max + " 周岁";
        } else if (!certnotype1.equals("身份证") || !certnotype2.equals("身份证")) {
          error = "证件类型必须是身份证";
        } else if (did.equals("100") && tmp_age1 < 18 && (name.equals(keepername) || certno.equals(keepercertno))) {
          error = "被保人是未成年人，投保人与被保人的姓名、证件号必须不一致";
        } else if (did.equals("100") && tmp_age1 >= 18 && (!name.equals(keepername) || !certno.equals(keepercertno))) {
          error = "被保人是成年人，投保人与被保人的姓名、证件号必须一致";
        } else if (did.equals("100") && !isCodeNameRepeat(j, keepername, keepercertno, rowList, 0, 3)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 9)) {
          error = "被保人在一份数据中不允许重复";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and " + did_scope + " and certno='" + certno + "'")) {
          error = "被保人已达到投保上限(1份)，无法继续投保";
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 6)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(0));
        bean1.setC2(tmp_list.get(1));
        bean1.setC3(tmp_list.get(2));
        bean1.setC4(tmp_list.get(3));
        bean1.setC5(tmp_list.get(4));
        bean1.setC6(tmp_list.get(5));
        bean1.setC7(tmp_list.get(6));
        bean1.setC8(tmp_list.get(7));
        bean1.setC9(tmp_list.get(8));
        bean1.setC10(tmp_list.get(9));
        bean1.setC11(tmp_list.get(10));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_pa_jiacheng_big_tj(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      int partx = 0;
      String price = this.mb.getPriceNew(did, jdbc);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String keepername = trim_all(tmp_list.get(1));
        String keepercertno = tmp_list.get(2);
        String number2 = tmp_list.get(3);
        String number4 = tmp_list.get(4);
        String number3 = tmp_list.get(5);
        String number5 = tmp_list.get(6);
        partx++;
        String number5_s = "1,2,3";
        int[] el1 = { 0, 1, 2, 3, 4, 5, 6, 7, 8 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.checkAge(keepercertno, 18, 65)) {
          error = "投保人年龄必须18-65周岁";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeatOld(j, number2, rowList, 3)) {
          error = "车牌号在一份数据中不允许重复";
        } else if (isValueRepeatOld(j, number3, rowList, 5)) {
          error = "发动机号在一份数据中不允许重复";
        } else if (isValueRepeatOld(j, number4, rowList, 4)) {
          error = "车架号在一份数据中不允许重复";
        } else if (!Tools.isCarNumber(number2)) {
          error = "无法识别车牌号";
        } else if (!Tools.isEngineNumber(number3)) {
          error = "无法识别发动机号";
        } else if (!Tools.isVin(number4)) {
          error = "无法识别车架号";
        } else if (!Tools.IsInArray(number5_s.split(","), number5)) {
          error = "核定座位数必须是1,2,3";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did=" + did + " " + 
            "and c3='" + number2 + "' and c4='" + number4 + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "车牌和车架一天内不允许提交2次";
        } else {
          int sum2 = Tools.getIntExcep(jdbc.selectOnlyField("select sum(part) from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + 
                policy_end + "') and did=" + did + " and c3='" + number2 + "' and c4='" + number4 + "'"));
          if (sum2 > 0)
            error = "车牌和车架已投保了" + sum2 + "份，超出投保上限（1份）"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, keepername, rowList, 1)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "投保人同名: " + keepername;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart("1");
        bean1.setFlag("1");
        bean1.setName(keepername);
        bean1.setCertno(keepercertno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_gz_gscryl(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Object>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Object> tmp_row = new ArrayList();
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      int partx = 0;
      String price = this.mb.getPriceNew(did, jdbc);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String ins_name = trim_all(tmp_list.get(1));
        String name = trim_all(tmp_list.get(4));
        String certno = tmp_list.get(5);
        String keepername = trim_all(tmp_list.get(2));
        String keepercertno = tmp_list.get(3);
        int part1 = Tools.getIntExcep(tmp_list.get(6));
        String tel = tmp_list.get(9);
        String email = tmp_list.get(8);
        partx += part1;
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        int[] el1 = { 1, 2, 3, 4, 5, 6, 7, 8, 9 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("国寿成人医疗")) {
          error = "方案名称错误";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.CheckStr(email) || !Tools.isEmail(email)) {
          error = "邮箱错误";
        } else if (!Tools.CheckStr(tel) || !Tools.isTel(tel)) {
          error = "手机号码错误";
        } else if (!certno.equals(keepercertno) || !name.equals(keepername)) {
          error = "投保人与被保人的必须一致";
        } else if (!Tools.checkAge(keepercertno, 18, 60)) {
          error = "投保人年龄必须18-60周岁";
        } else if (!Tools.checkAge(certno, 18, 60)) {
          error = "被保人年龄必须18-60周岁";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 0, 2)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 5)) {
          error = "被保人在一份数据中不允许重复";
        } else if (part1 != 1) {
          error = "投保份数必须是1";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and did=" + did + " and certno='" + certno + "'")) {
          error = "被保人已达到投保上限(1份)，无法继续投保";
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 4)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(String.valueOf(part1));
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(0));
        bean1.setC2(tmp_list.get(1));
        bean1.setC3(tmp_list.get(2));
        bean1.setC4(tmp_list.get(3));
        bean1.setC5(tmp_list.get(4));
        bean1.setC6(tmp_list.get(5));
        bean1.setC7(tmp_list.get(6));
        bean1.setC8(tmp_list.get(7));
        bean1.setC9(tmp_list.get(8));
        bean1.setC10(tmp_list.get(9));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_jx_childrenA(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Object>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Object> tmp_row = new ArrayList();
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      int partx = 0;
      String price = this.mb.getPriceNew(did, jdbc);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String name = trim_all(tmp_list.get(4));
        String certno = tmp_list.get(6);
        String keepername = trim_all(tmp_list.get(0));
        String keepercertno = tmp_list.get(2);
        int part1 = Tools.getIntExcep(tmp_list.get(9));
        String guanxi = tmp_list.get(3);
        String certtype1 = tmp_list.get(1);
        String certtype2 = tmp_list.get(5);
        String birthday1 = tmp_list.get(7);
        String sex1 = tmp_list.get(8);
        String tel = tmp_list.get(10);
        String email = tmp_list.get(11);
        partx += part1;
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        int days = 0;
        if (Tools.isCard(certno)) {
          Map tmp_map = Tools.getBirthday(certno);
          String tmp_sex = (String)tmp_map.get("sexCode");
          String tmp_birth = (String)tmp_map.get("birthday");
          days = Tools.differentDays(tmp_birth, Tools.getDate());
          if (!birthday1.equals(tmp_birth)) {
            tmp_list.set(7, tmp_birth);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex)) {
            tmp_list.set(8, tmp_sex);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = String.valueOf(warning) + "被保人性别错误";
          } 
        } 
        int[] el1 = { 
            0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 
            10, 11 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.CheckStr(email) || !Tools.isEmail(email)) {
          error = "邮箱错误";
        } else if (!Tools.CheckStr(tel) || !Tools.isTel(tel)) {
          error = "手机号码错误";
        } else if (certno.equals(keepercertno)) {
          error = "投保人与被保人的证件号必须不一致";
        } else if (name.equals(keepername)) {
          error = "投保人与被保人的姓名必须不一致";
        } else if (!Tools.checkAge(keepercertno, 18, 200)) {
          error = "投保人年龄必须大于18周岁";
        } else if (!Tools.checkAge(certno, 0, 18)) {
          error = "被保人年龄必须 0-18周岁";
        } else if (days <= 30) {
          error = "被保人年龄必须大于30天";
        } else if (!certtype1.equals("身份证") || !certtype2.equals("身份证")) {
          error = "证件类型必须为身份证";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 0, 2)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 6)) {
          error = "被保人在一份数据中不允许重复";
        } else if (!guanxi.equals("子女")) {
          error = "与被保险人关系必须是子女";
        } else if (part1 != 1) {
          error = "投保份数必须是1";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and did=" + did + " and certno='" + certno + "'")) {
          error = "被保人已达到投保上限(1份)，无法继续投保";
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 4)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(String.valueOf(part1));
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(0));
        bean1.setC2(tmp_list.get(1));
        bean1.setC3(tmp_list.get(2));
        bean1.setC4(tmp_list.get(3));
        bean1.setC5(tmp_list.get(4));
        bean1.setC6(tmp_list.get(5));
        bean1.setC7(tmp_list.get(6));
        bean1.setC8(tmp_list.get(7));
        bean1.setC9(tmp_list.get(8));
        bean1.setC10(tmp_list.get(9));
        bean1.setC11(tmp_list.get(10));
        bean1.setC12(tmp_list.get(11));
        bean1.setC13(tmp_list.get(12));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_pa_jiacheng_bj(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      int partx = 0;
      String price = this.mb.getPriceNew(did, jdbc);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String ins_name = tmp_list.get(10);
        String keepername = trim_all(tmp_list.get(1));
        String keepercertno = tmp_list.get(2);
        String number2 = tmp_list.get(4);
        String number4 = tmp_list.get(5);
        String number3 = tmp_list.get(6);
        String number5 = tmp_list.get(8);
        String bf = tmp_list.get(9);
        String cbgs = tmp_list.get(10);
        partx++;
        String number5_s = "2,3";
        int[] el1 = { 
            1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 
            11 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("北京") && did.equals("60")) {
          error = "承保公司必须为北京";
        } else if (!ins_name.equals("北京") && did.equals("64")) {
          error = "承保公司必须为北京";
        } else if (did.equals("60") && !Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!bf.equals("1200")) {
          error = "保费错误";
        } else if (!cbgs.equals("北京")) {
          error = "承保公司错误";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeatOld(j, number2, rowList, 4)) {
          error = "车牌号在一份数据中不允许重复";
        } else if (isValueRepeatOld(j, number3, rowList, 6)) {
          error = "发动机号在一份数据中不允许重复";
        } else if (isValueRepeatOld(j, number4, rowList, 5)) {
          error = "车架号在一份数据中不允许重复";
        } else if (!Tools.isCarNumber(number2)) {
          error = "无法识别车牌号";
        } else if (!Tools.isEngineNumber(number3)) {
          error = "无法识别发动机号";
        } else if (!Tools.isVin(number4)) {
          error = "无法识别车架号";
        } else if (!Tools.IsInArray(number5_s.split(","), number5)) {
          error = "核定座位数必须是" + number5_s;
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did in (60,64) and (c4='" + 
            number2 + "' or c5='" + number3 + "' or c6='" + number4 + "') and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "车牌、发动机号和车架号一天内不允许提交2次";
        } else {
          int sum2 = Tools.getIntExcep(jdbc.selectOnlyField("select sum(part) from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + 
                policy_end + "') and did in (" + "60,64" + ") and (c4='" + number2 + "' or c5='" + number3 + "' or c6='" + number4 + "')"));
          if (sum2 > 0)
            error = "车牌、发动机号和车架号已投保了" + sum2 + "份，超出投保上限（1份）"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, number2, rowList, 4)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "车牌重复: " + number2;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart("1");
        bean1.setFlag("1");
        bean1.setName(keepername);
        bean1.setCertno(keepercertno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_pa_jiacheng_big_sb(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      int partx = 0;
      String price = this.mb.getPriceNew(did, jdbc);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String keepername = trim_all(tmp_list.get(1));
        String keepercertno = tmp_list.get(2);
        String number2 = tmp_list.get(4);
        String number4 = tmp_list.get(5);
        String number3 = tmp_list.get(6);
        String number5 = tmp_list.get(8);
        partx++;
        String number5_s = "1,2,3";
        String certno = keepercertno.replaceAll("[^a-z^A-Z]", "");
        int[] el1 = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 11 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (certno.length() <= 1 && !Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (certno.length() <= 1 && Tools.isCard(keepercertno) && !Tools.checkAge(keepercertno, 18, 65)) {
          error = "投保人年龄必须18-65周岁";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeatOld(j, number2, rowList, 4)) {
          error = "车牌号在一份数据中不允许重复";
        } else if (isValueRepeatOld(j, number3, rowList, 6)) {
          error = "发动机号在一份数据中不允许重复";
        } else if (isValueRepeatOld(j, number4, rowList, 5)) {
          error = "车架号在一份数据中不允许重复";
        } else if (!Tools.isCarNumber(number2)) {
          error = "无法识别车牌号";
        } else if (!Tools.isEngineNumber(number3)) {
          error = "无法识别发动机号";
        } else if (!Tools.isVin(number4)) {
          error = "无法识别车架号";
        } else if (!Tools.IsInArray(number5_s.split(","), number5)) {
          error = "核定座位数必须是1,2,3";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did=" + did + " " + 
            "and c4='" + number2 + "' and c6='" + number4 + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "车牌和车架一天内不允许提交2次";
        } else {
          int sum2 = Tools.getIntExcep(jdbc.selectOnlyField("select sum(part) from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + 
                policy_end + "') and did=" + did + " and c4='" + number2 + "' and c6='" + number3 + "'"));
          if (sum2 > 0)
            error = "车牌和车架已投保了" + sum2 + "份，超出投保上限（1份）"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, keepername, rowList, 1)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "投保人同名: " + keepername;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart("1");
        bean1.setFlag("1");
        bean1.setName(keepername);
        bean1.setCertno(keepercertno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_pa_jiacheng(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      int partx = 0;
      String price = this.mb.getPriceNew(did, jdbc);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String keepername = trim_all(tmp_list.get(1));
        String keepercertno = tmp_list.get(3);
        int part1 = Tools.getIntExcep(tmp_list.get(9));
        String tel = tmp_list.get(4);
        String number2 = tmp_list.get(5);
        String number3 = tmp_list.get(6);
        String number4 = tmp_list.get(7);
        String number5 = tmp_list.get(8);
        partx += part1;
        keepercertno = keepercertno.toLowerCase();
        String tmp_sex = "";
        String tmp_birth = "";
        if (Tools.isCard(keepercertno)) {
          Map tmp_map = Tools.getBirthday(keepercertno);
          tmp_sex = (String)tmp_map.get("sexCode");
          tmp_birth = (String)tmp_map.get("birthday");
        } 
        String number5_s = "2,3,4,5,6,7,8,9";
        int[] el1 = { 1, 2, 3, 5, 6, 7, 8, 9 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.checkAge(keepercertno, 18, 65)) {
          error = "投保人年龄必须18-65周岁";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 1, 3)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (isValueRepeatOld(j, number2, rowList, 5)) {
          error = "车牌号在一份数据中不允许重复";
        } else if (isValueRepeatOld(j, number3, rowList, 6)) {
          error = "发动机号在一份数据中不允许重复";
        } else if (isValueRepeatOld(j, number4, rowList, 7)) {
          error = "车架号在一份数据中不允许重复";
        } else if (Tools.CheckStr(tel) && !Tools.isTel(tel)) {
          error = "无法识别手机号";
        } else if (!Tools.isCarNumber(number2)) {
          error = "无法识别车牌号";
        } else if (!Tools.isEngineNumber(number3)) {
          error = "无法识别发动机号";
        } else if (!Tools.isVin(number4)) {
          error = "无法识别车架号";
        } else if (!Tools.IsInArray(number5_s.split(","), number5)) {
          error = "核定座位数必须是2-9之间的数字";
        } else if (part1 < 1 || part1 > 5) {
          error = "购买份数必须是1-5份";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did=" + did + 
            " and c12='" + number2 + "' and c14='" + number4 + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "车牌和车架一天内不允许提交2次";
        } else {
          int sum2 = Tools.getIntExcep(jdbc.selectOnlyField("select sum(c16) from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + 
                policy_end + "') and did=" + did + " and c12='" + number2 + "' and c14='" + number4 + "'"));
          if (part1 + sum2 > 5)
            error = "车牌和车架已投保了" + sum2 + "份，超出投保上限（5份）"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, keepername, rowList, 1)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "投保人同名: " + keepername;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(keepername);
        bean1.setCertno(keepercertno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_sex);
        bean1.setC3(tmp_list.get(2));
        bean1.setC4(tmp_list.get(3));
        bean1.setC5(tmp_birth);
        bean1.setC6(tmp_list.get(4));
        bean1.setC7(tmp_list.get(1));
        bean1.setC8(tmp_sex);
        bean1.setC9(tmp_list.get(2));
        bean1.setC10(tmp_list.get(3));
        bean1.setC11(tmp_birth);
        bean1.setC12(tmp_list.get(5));
        bean1.setC13(tmp_list.get(6));
        bean1.setC14(tmp_list.get(7));
        bean1.setC15(tmp_list.get(8));
        bean1.setC16(tmp_list.get(9));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_pa_jiacheng_big(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Object>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Object> tmp_row = new ArrayList();
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      int partx = 0;
      String price = this.mb.getPriceNew(did, jdbc);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String keepername = trim_all(tmp_list.get(3));
        String keepercertno = tmp_list.get(4);
        String number2 = tmp_list.get(0);
        String number3 = tmp_list.get(2);
        String number4 = tmp_list.get(1);
        String number5 = tmp_list.get(5);
        partx++;
        keepercertno = keepercertno.toLowerCase();
        String number5_s = "2,3";
        int[] el1 = { 0, 1, 2, 3, 4, 5 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.checkAge(keepercertno, 18, 65)) {
          error = "投保人年龄必须18-65周岁";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 3, 4)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (isValueRepeatOld(j, number2, rowList, 0)) {
          error = "车牌号在一份数据中不允许重复";
        } else if (isValueRepeatOld(j, number3, rowList, 2)) {
          error = "发动机号在一份数据中不允许重复";
        } else if (isValueRepeatOld(j, number4, rowList, 1)) {
          error = "车架号在一份数据中不允许重复";
        } else if (!Tools.isCarNumber(number2)) {
          error = "无法识别车牌号";
        } else if (!Tools.isEngineNumber(number3)) {
          error = "无法识别发动机号";
        } else if (!Tools.isVin(number4)) {
          error = "无法识别车架号";
        } else if (!Tools.IsInArray(number5_s.split(","), number5)) {
          error = "核定座位数必须是2,3";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did=" + did + " " + 
            "and c1='" + number2 + "' and c2='" + number4 + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "车牌和车架一天内不允许提交2次";
        } else {
          int sum2 = Tools.getIntExcep(jdbc.selectOnlyField("select sum(part) from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + 
                policy_end + "') and did=" + did + " and c1='" + number2 + "' and c2='" + number4 + "'"));
          if (sum2 > 0)
            error = "车牌和车架已投保了" + sum2 + "份，超出投保上限（1份）"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, keepername, rowList, 1)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "投保人同名: " + keepername;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart("1");
        bean1.setFlag("1");
        bean1.setName(keepername);
        bean1.setCertno(keepercertno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(0));
        bean1.setC2(tmp_list.get(1));
        bean1.setC3(tmp_list.get(2));
        bean1.setC4(tmp_list.get(3));
        bean1.setC5(tmp_list.get(4));
        bean1.setC6(tmp_list.get(5));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_ha_gs(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Object>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Object> tmp_row = new ArrayList();
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      int partx = 0;
      String price = this.mb.getPriceNew(did, jdbc);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String name = trim_all(tmp_list.get(13));
        String certno = tmp_list.get(20);
        String keepername = trim_all(tmp_list.get(2));
        String keepercertno = tmp_list.get(6);
        int part1 = Tools.getIntExcep(tmp_list.get(36));
        String guanxi1 = tmp_list.get(12);
        String guanxi2 = tmp_list.get(15);
        String sex1 = tmp_list.get(3);
        String birthday1 = tmp_list.get(4);
        String sex2 = tmp_list.get(17);
        String birthday2 = tmp_list.get(18);
        birthday1 = birthday1.replaceAll("/", "-");
        birthday2 = birthday2.replaceAll("/", "-");
        String certtype1 = tmp_list.get(5);
        String certtype2 = tmp_list.get(16);
        String certtype3 = tmp_list.get(19);
        partx += part1;
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        if (Tools.isCard(certno)) {
          Map tmp_map = Tools.getBirthday(certno);
          String tmp_sex = (String)tmp_map.get("sexCode");
          String tmp_birth = (String)tmp_map.get("birthday");
          tmp_sex = tmp_sex.equals("男") ? "M" : "F";
          if (!birthday2.equals(tmp_birth)) {
            tmp_list.set(18, tmp_birth);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex2.equals(tmp_sex)) {
            tmp_list.set(17, tmp_sex);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = String.valueOf(warning) + "被保人性别错误";
          } 
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map = Tools.getBirthday(keepercertno);
          String tmp_sex = (String)tmp_map.get("sexCode");
          String tmp_birth = (String)tmp_map.get("birthday");
          tmp_sex = tmp_sex.equals("男") ? "M" : "F";
          if (!birthday1.equals(tmp_birth)) {
            tmp_list.set(4, tmp_birth);
            warning = "投保人生日错误";
          } 
          if (!sex1.equals(tmp_sex)) {
            tmp_list.set(3, tmp_sex);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = String.valueOf(warning) + "投保人性别错误";
          } 
        } 
        int[] el1 = { 
            0, 1, 2, 3, 4, 5, 6, 12, 13, 14, 
            15, 16, 17, 18, 19, 20, 36 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!certno.equals(keepercertno)) {
          error = "投保人与被保人的证件号姓名不一致";
        } else if (!name.equals(keepername)) {
          error = "投保人与被保人的姓名不一致";
        } else if (!Tools.checkAge(keepercertno, 18, 60)) {
          error = "投保人年龄必须18-60周岁";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 6)) {
          error = "投保人在一份数据中不允许重复";
        } else if (!certtype1.equals("I")) {
          error = "投保人证件类别必须为I";
        } else if (!certtype2.equals("I")) {
          error = "被保险人类型必须为I";
        } else if (!certtype3.equals("I")) {
          error = "证件类别必须为I";
        } else if (!guanxi1.equals("M-本人")) {
          error = "与被保险人关系不是M-本人";
        } else if (!guanxi2.equals("M-本人")) {
          error = "与主被保险人关系不是M-本人";
        } else if (part1 != 1) {
          error = "投保份数必须是1";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did=" + did + " and c7='" + keepercertno + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "投保人一天内不允许提交2次";
        } else {
          int sum2 = Tools.getIntExcep(jdbc.selectOnlyField("select sum(c37) from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + 
                policy_end + "') and did=" + did + " and c7='" + keepercertno + "'"));
          if (part1 + sum2 > 1)
            error = "投保人已投保了" + sum2 + "份，超出投保上限（1份）"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 2)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "投保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(String.valueOf(part1));
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(0));
        bean1.setC2(tmp_list.get(1));
        bean1.setC3(tmp_list.get(2));
        bean1.setC4(tmp_list.get(3));
        bean1.setC5(tmp_list.get(4));
        bean1.setC6(tmp_list.get(5));
        bean1.setC7(tmp_list.get(6));
        bean1.setC8(tmp_list.get(7));
        bean1.setC9(tmp_list.get(8));
        bean1.setC10(tmp_list.get(9));
        bean1.setC11(tmp_list.get(10));
        bean1.setC12(tmp_list.get(11));
        bean1.setC13(tmp_list.get(12));
        bean1.setC14(tmp_list.get(13));
        bean1.setC15(tmp_list.get(14));
        bean1.setC16(tmp_list.get(15));
        bean1.setC17(tmp_list.get(16));
        bean1.setC18(tmp_list.get(17));
        bean1.setC19(tmp_list.get(18));
        bean1.setC20(tmp_list.get(19));
        bean1.setC21(tmp_list.get(20));
        bean1.setC22(tmp_list.get(21));
        bean1.setC23(tmp_list.get(22));
        bean1.setC24(tmp_list.get(23));
        bean1.setC25(tmp_list.get(24));
        bean1.setC26(tmp_list.get(25));
        bean1.setC27(tmp_list.get(26));
        bean1.setC28(tmp_list.get(27));
        bean1.setC29(tmp_list.get(28));
        bean1.setC30(tmp_list.get(29));
        bean1.setC31(tmp_list.get(30));
        bean1.setC32(tmp_list.get(31));
        bean1.setC33(tmp_list.get(32));
        bean1.setC34(tmp_list.get(33));
        bean1.setC35(tmp_list.get(34));
        bean1.setC36(tmp_list.get(35));
        bean1.setC37(tmp_list.get(36));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_sc(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Object>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Object> tmp_row = new ArrayList();
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      int partx = 0;
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String name = trim_all(tmp_list.get(4));
        String certno = tmp_list.get(6);
        String keepername = trim_all(tmp_list.get(0));
        String keepercertno = tmp_list.get(2);
        String birthday = tmp_list.get(7);
        String sex = tmp_list.get(8);
        String classify = tmp_list.get(12);
        String guanxi = tmp_list.get(3);
        int part1 = Tools.getIntExcep(tmp_list.get(9));
        partx += part1;
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        String error = "", warning = "";
        if (Tools.isCard(certno)) {
          Map tmp_map2 = Tools.getBirthday(certno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday.equals(tmp_birthday2)) {
            tmp_list.set(7, tmp_birthday2);
            warning = "投保人生日错误";
          } 
          if (!sex.equals(tmp_sex2)) {
            tmp_list.set(8, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人性别错误";
          } 
        } 
        int[] el1 = { 
            0, 1, 2, 3, 4, 5, 6, 8, 9, 12, 
            13 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!name.equals(keepername) || !certno.equals(keepercertno)) {
          error = "投保人和被保人身份证号必须一致";
        } else if (!Tools.checkAge(keepercertno, 18, 65)) {
          error = "投保人年龄必须 18-65周岁";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 2)) {
          error = "投保人在一份数据中不允许重复";
        } else if (guanxi.indexOf("本人") == -1) {
          error = "与被保险人关系不是本人";
        } else if ((did.equals("39") || did.equals("43")) && !Tools.IsInArray("1,2,3,4".split(","), classify)) {
          error = "职业类别超范围";
        } else if (did.equals("44") && !Tools.IsInArray("1,2,3,4,5,6".split(","), classify)) {
          error = "职业类别超范围";
        } else if (did.equals("40") && !Tools.IsInArray("1,2,3,4,5,6".split(","), classify)) {
          error = "职业类别超范围";
        } else if (did.equals("41") && !Tools.IsInArray("1,2,3,4,5,6".split(","), classify)) {
          error = "职业类别超范围";
        } else if (part1 < 1 || part1 > 3) {
          error = "份数最多3份";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did=" + did + " and c7='" + certno + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "被保人一天内不允许提交2次";
        } else {
          int sum2 = Tools.getIntExcep(jdbc.selectOnlyField("select sum(c10) from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + 
                policy_end + "') and did=" + did + " and c7='" + certno + "'"));
          if (part1 + sum2 > 3)
            error = "被保人已投保了" + sum2 + "份，超出投保上限（3份）"; 
          if (did.equals("39")) {
            if (jdbc.checkSql("select id from data_post_list where did in (40,41,43,44) and c7='" + certno + "'"))
              error = "不允许投保除'SC人保财1-4 10+1+60'的其它方案"; 
          } else if (did.equals("40")) {
            if (jdbc.checkSql("select id from data_post_list where did in (39,41,43,44) and c7='" + certno + "'"))
              error = "不允许投保除'SC人保财1-6 10+1+60'的其它方案"; 
          } else if (did.equals("41")) {
            if (jdbc.checkSql("select id from data_post_list where did in (39,40,43,44) and c7='" + certno + "'"))
              error = "不允许投保除'SC人保财1-6 10+2+60'的其它方案"; 
          } else if (did.equals("43")) {
            if (jdbc.checkSql("select id from data_post_list where did in (39,40,41,44) and c7='" + certno + "'"))
              error = "不允许投保除'SC人保财1-4 10+2+60'的其它方案"; 
          } else if (did.equals("44") && 
            jdbc.checkSql("select id from data_post_list where did in (39,40,41,43) and c7='" + certno + "'")) {
            error = "不允许投保除'SC人保财1-6分段 10+1+60'的其它方案";
          } 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 0)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(0));
        bean1.setC2(tmp_list.get(1));
        bean1.setC3(tmp_list.get(2));
        bean1.setC4(tmp_list.get(3));
        bean1.setC5(tmp_list.get(4));
        bean1.setC6(tmp_list.get(5));
        bean1.setC7(tmp_list.get(6));
        bean1.setC8(tmp_list.get(7));
        bean1.setC9(tmp_list.get(8));
        bean1.setC10(tmp_list.get(9));
        bean1.setC11(tmp_list.get(10));
        bean1.setC12(tmp_list.get(11));
        bean1.setC13(tmp_list.get(12));
        bean1.setC14(tmp_list.get(13));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_jl_14(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String ins_name = tmp_list.get(1);
        String name = trim_all(tmp_list.get(2));
        String certno = tmp_list.get(4);
        String keepername = trim_all(tmp_list.get(6));
        if (Tools.CheckStr(certno))
          certno = certno.toLowerCase(); 
        int[] el1 = { 1, 2, 3, 4, 5, 6, 7 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("JL国寿1-4  10+1+30") && did.equals("65")) {
          error = "方案名称错误";
        } else if (!ins_name.equals("JL国寿1-4  5+2+30") && did.equals("66")) {
          error = "方案名称错误";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!name.equals(keepername)) {
          error = "投保人和被保人必须同名";
        } else if (!Tools.checkAge(certno, 18, 65)) {
          error = "被保人年龄必须 18-65 周岁";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 4)) {
          error = "被保人在一份数据中不允许重复";
        } else {
          ArrayList<DataPostListBean> oldList = jdbc.db_select("select id,uid,did,read_dt,post_dt,time1,time2,time3,sn,part,policy_number,policy_begin,policy_end,flag,back_cause,back_part,name,certno,keepername,keepercertno,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,c20,c21,c22,c23,c24,c25,c26,c27,c28,c29,c30,c31,c32,c33,c34,c35,c36,c37,c38,c39,c40,error,warning,pz,mylock from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and " + 
              "did in (" + "65,66" + ") and c4='" + certno + "'", DataPostListBean.class);
          if (oldList.size() > 0) {
            int old_part = 0;
            for (int x = 0; x < oldList.size(); x++) {
              DataPostListBean postx = oldList.get(x);
              old_part += Tools.getIntExcep(postx.getPart());
            } 
            if (old_part >= 2) {
              error = "被保人已达到投保上限(2份)，无法继续投保";
            } else if (old_part == 1 && part.equals("2")) {
              error = "被保人已投保了1份，无法继续投保2份，请选择1份";
            } 
          } 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 2)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(certno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_gs_dl14(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      int partx = 0;
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String name = trim_all(tmp_list.get(1));
        String certno = tmp_list.get(2);
        String age = tmp_list.get(3);
        int part1 = Tools.getIntExcep(tmp_list.get(5));
        partx += part1;
        certno = certno.toLowerCase();
        if (Tools.isCard(certno)) {
          Map tmp_map = Tools.getBirthday(certno);
          String tmp_age = (String)tmp_map.get("age");
          if (!age.equals(tmp_age)) {
            tmp_list.set(3, tmp_age);
            warning = "年龄错误";
          } 
        } 
        int[] el1 = { 1, 2, 3, 4, 5 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (!Tools.checkAge(certno, 18, 65)) {
          error = "被保人年龄必须 18-65 周岁";
        } else if (isValueRepeat(j, certno, rowList, 2)) {
          error = "被保人在一份数据中不允许重复";
        } else if (part1 < 1 || part1 > 3) {
          error = "份数最多3份";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did in (83,84,85,86,87) and c2='" + certno + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "身份证号一天内不允许提交2次";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') " + 
            "and did not in (" + did + ") and c2='" + certno + "'")) {
          error = "一个人能且只能做其中一个方案，不可混投";
        } else {
          ArrayList<String> oldList = jdbc.selectList("select part*c5 from data_post_list where (policy_end is null or Date(policy_end)>'" + policy_end + "') and " + 
              "did='" + did + "' and c2='" + certno + "'");
          if (oldList.size() > 0) {
            int old_part = 0;
            for (int x = 0; x < oldList.size(); x++) {
              String tmp_part = oldList.get(x);
              old_part += Tools.getIntExcep(tmp_part);
            } 
            if (old_part >= 3) {
              error = "被保人已达到投保上限(3份)，无法继续投保";
            } else if (old_part == 1 && part1 == 3) {
              error = "被保人已投保了1份，无法继续投保3份";
            } else if (old_part == 2 && part1 == 2) {
              error = "被保人已投保了2份，无法继续投保2份";
            } else if (old_part == 2 && part1 == 3) {
              error = "被保人已投保了2份，无法继续投保3份";
            } 
          } 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 1)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(name);
        bean1.setKeepercertno(certno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_gs_dl16(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      int partx = 0;
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String name = trim_all(tmp_list.get(1));
        String certno = tmp_list.get(2);
        int part1 = Tools.getIntExcep(tmp_list.get(4));
        partx += part1;
        certno = certno.toLowerCase();
        int[] el1 = { 1, 2, 3, 4 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (!Tools.checkAge(certno, 18, 65)) {
          error = "被保人年龄必须 18-65 周岁";
        } else if (isValueRepeat(j, certno, rowList, 2)) {
          error = "被保人在一份数据中不允许重复";
        } else if (part1 < 1 || part1 > 3) {
          error = "份数最多3份";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did in (83,84,85,86,87) and c2='" + certno + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "身份证号一天内不允许提交2次";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') " + 
            "and did not in (" + did + ") and c2='" + certno + "'")) {
          error = "一个人能且只能做其中一个方案，不可混投";
        } else {
          ArrayList<String> oldList = jdbc.db_select("select part*c4 from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and " + 
              "did='" + did + "' and c2='" + certno + "'", DataPostListBean.class);
          if (oldList.size() > 0) {
            int old_part = 0;
            for (int x = 0; x < oldList.size(); x++) {
              String tmp_part = oldList.get(x);
              old_part += Tools.getIntExcep(tmp_part);
            } 
            if (old_part >= 3) {
              error = "被保人已达到投保上限(3份)，无法继续投保";
            } else if (old_part == 1 && part1 == 3) {
              error = "被保人已投保了1份，无法继续投保3份";
            } else if (old_part == 2 && part1 == 2) {
              error = "被保人已投保了2份，无法继续投保2份";
            } else if (old_part == 2 && part1 == 3) {
              error = "被保人已投保了2份，无法继续投保3份";
            } 
          } 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 1)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(name);
        bean1.setKeepercertno(certno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_bsgs(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      int partx = 0;
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String ins_name = tmp_list.get(7);
        String class_name = tmp_list.get(5);
        String name = trim_all(tmp_list.get(1));
        String certno = tmp_list.get(2);
        String age = tmp_list.get(3);
        String sex = tmp_list.get(4);
        String ok_data = tmp_list.get(11);
        int part1 = Tools.getIntExcep(tmp_list.get(8));
        partx += part1;
        certno = certno.toLowerCase();
        if (Tools.isCard(certno)) {
          Map tmp_map = Tools.getBirthday(certno);
          String tmp_sex = (String)tmp_map.get("sexCode");
          String tmp_age = (String)tmp_map.get("age");
          if (!age.equals(tmp_age)) {
            tmp_list.set(3, tmp_age);
            warning = "年龄错误";
          } 
          if (!sex.equals(tmp_sex)) {
            tmp_list.set(4, tmp_sex);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = String.valueOf(warning) + "性别错误";
          } 
        } 
        int[] el1 = { 1, 2, 3, 4, 6, 8, 11 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (class_name.indexOf("1-4类全额赔付5-6类保额减半") == -1 && did.equals("26")) {
          error = "类别错误";
        } else if (class_name.indexOf("1-4类全额赔付5-6类保额减半") == -1 && did.equals("27")) {
          error = "类别错误";
        } else if (class_name.indexOf("1-4类全额赔付5-6类保额减半") == -1 && did.equals("28")) {
          error = "类别错误";
        } else if (class_name.indexOf("1-4类全额赔付5-6类保额减半") == -1 && did.equals("31")) {
          error = "类别错误";
        } else if (class_name.indexOf("1-6类全额赔付") == -1 && did.equals("29")) {
          error = "类别错误";
        } else if (class_name.indexOf("1-6类全额赔付") == -1 && did.equals("30")) {
          error = "类别错误";
        } else if (ins_name.indexOf("10+1+50") == -1 && did.equals("26")) {
          error = "投保方案(保额)错误";
        } else if (ins_name.indexOf("10+2+50") == -1 && did.equals("28")) {
          error = "投保方案(保额)错误";
        } else if (ins_name.indexOf("5+2+50") == -1 && did.equals("27")) {
          error = "投保方案(保额)错误";
        } else if (ins_name.indexOf("10+1+50") == -1 && did.equals("29")) {
          error = "投保方案(保额)错误";
        } else if (ins_name.indexOf("10+2+50") == -1 && did.equals("30")) {
          error = "投保方案(保额)错误";
        } else if (ins_name.indexOf("10+1+1+50") == -1 && did.equals("31")) {
          error = "投保方案(保额)错误";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (!Tools.checkAge(certno, 18, 65)) {
          error = "被保人年龄必须 18-65 周岁";
        } else if (isValueRepeat(j, certno, rowList, 2)) {
          error = "被保人在一份数据中不允许重复";
        } else if (part1 < 1 || part1 > 3) {
          error = "份数最多3份";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did in (26,27,28,29,30,31) and c2='" + certno + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "身份证号一天内不允许提交2次";
        } else {
          ArrayList<DataPostListBean> oldList = jdbc.db_select("select id,uid,did,read_dt,post_dt,time1,time2,time3,sn,part,policy_number,policy_begin,policy_end,flag,back_cause,back_part,name,certno,keepername,keepercertno,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,c20,c21,c22,c23,c24,c25,c26,c27,c28,c29,c30,c31,c32,c33,c34,c35,c36,c37,c38,c39,c40,error,warning,pz,mylock from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and " + 
              "did in (" + "26,27,28,29,30,31" + ") and c2='" + certno + "'", DataPostListBean.class);
          if (oldList.size() > 0) {
            int old_part = 0;
            for (int x = 0; x < oldList.size(); x++) {
              DataPostListBean postx = oldList.get(x);
              old_part += Tools.getIntExcep(postx.getPart());
            } 
            if (old_part >= 3) {
              error = "被保人已达到投保上限(3份)，无法继续投保";
            } else if (old_part == 1 && part.equals("3")) {
              error = "被保人已投保了1份，无法继续投保3份";
            } else if (old_part == 2 && part.equals("2")) {
              error = "被保人已投保了2份，无法继续投保2份";
            } else if (old_part == 2 && part.equals("3")) {
              error = "被保人已投保了2份，无法继续投保3份";
            } 
          } 
          String time1 = Tools.plusDayNoZero(1, Tools.getCurrentDate());
          if (!time1.equals(ok_data))
            error = "生效日期有问题"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 1)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(name);
        bean1.setKeepercertno(certno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_hzgs(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      int partx = 0;
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String ins_name = tmp_list.get(7);
        String class_name = tmp_list.get(5);
        String name = trim_all(tmp_list.get(1));
        String certno = tmp_list.get(2);
        String age = tmp_list.get(3);
        String sex = tmp_list.get(4);
        String ok_data = tmp_list.get(11);
        int part1 = Tools.getIntExcep(tmp_list.get(8));
        partx += part1;
        certno = certno.toLowerCase();
        if (Tools.isCard(certno)) {
          Map tmp_map = Tools.getBirthday(certno);
          String tmp_sex = (String)tmp_map.get("sexCode");
          String tmp_age = (String)tmp_map.get("age");
          if (!age.equals(tmp_age)) {
            tmp_list.set(3, tmp_age);
            warning = "年龄错误";
          } 
          if (!sex.equals(tmp_sex)) {
            tmp_list.set(4, tmp_sex);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = String.valueOf(warning) + "性别错误";
          } 
        } 
        int[] el1 = { 1, 2, 3, 4, 6, 8, 11 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!class_name.equals("1-4类") && did.equals("32")) {
          error = "类别错误";
        } else if (!class_name.equals("1-4类") && did.equals("33")) {
          error = "类别错误";
        } else if (!class_name.equals("1-6类全额赔付") && did.equals("34")) {
          error = "类别错误";
        } else if (!class_name.equals("1-6类全额赔付") && did.equals("35")) {
          error = "类别错误";
        } else if (!ins_name.equals("10+1+50") && did.equals("32")) {
          error = "投保方案(保额)错误";
        } else if (!ins_name.equals("5+2+50") && did.equals("33")) {
          error = "投保方案(保额)错误";
        } else if (!ins_name.equals("10+1+50") && did.equals("34")) {
          error = "投保方案(保额)错误";
        } else if (!ins_name.equals("10+2+50") && did.equals("35")) {
          error = "投保方案(保额)错误";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (!Tools.checkAge(certno, 18, 65)) {
          error = "被保人年龄必须 18-65 周岁";
        } else if (isValueRepeat(j, certno, rowList, 2)) {
          error = "被保人在一份数据中不允许重复";
        } else if (part1 < 1 || part1 > 2) {
          error = "份数最多2份";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did in (32,33,34,35) and c2='" + certno + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "身份证号一天内不允许提交2次";
        } else {
          ArrayList<DataPostListBean> oldList = jdbc.db_select("select id,uid,did,read_dt,post_dt,time1,time2,time3,sn,part,policy_number,policy_begin,policy_end,flag,back_cause,back_part,name,certno,keepername,keepercertno,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,c20,c21,c22,c23,c24,c25,c26,c27,c28,c29,c30,c31,c32,c33,c34,c35,c36,c37,c38,c39,c40,error,warning,pz,mylock from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') " + 
              "and did in (" + "32,33,34,35" + ") and c2='" + certno + "'", DataPostListBean.class);
          if (oldList.size() > 0) {
            int old_part = 0;
            for (int x = 0; x < oldList.size(); x++) {
              DataPostListBean postx = oldList.get(x);
              old_part += Tools.getIntExcep(postx.getPart());
            } 
            if (old_part >= 2) {
              error = "被保人已达到投保上限(2份)，无法继续投保";
            } else if (old_part == 1 && part.equals("2")) {
              error = "被保人已投保了1份，无法继续投保2份";
            } else if (old_part == 2 && part.equals("1")) {
              error = "被保人已投保了2份，无法继续投保1份";
            } else if (old_part == 2 && part.equals("2")) {
              error = "被保人已投保了2份，无法继续投保2份";
            } 
          } 
          String time1 = Tools.plusDayNoZero(1, Tools.getCurrentDate());
          if (!time1.equals(ok_data))
            error = "生效日期有问题"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 1)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(name);
        bean1.setKeepercertno(certno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_guoshou(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Object>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Object> tmp_row = new ArrayList();
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      int partx = 0;
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String name = trim_all(tmp_list.get(0));
        String certno = tmp_list.get(1);
        int part1 = Tools.getIntExcep(tmp_list.get(3));
        partx += part1;
        certno = certno.toLowerCase();
        String error = "", warning = "";
        int[] el1 = { 0, 1, 2, 3 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人或投保人被限制投保(黑名单)";
        } else if (!Tools.checkAge(certno, 18, 65)) {
          error = "被保人年龄必须 18-65 周岁";
        } else if (isValueRepeat(j, certno, rowList, 1)) {
          error = "被保人在一份数据中不允许重复";
        } else if (part1 < 1 || part1 > 2) {
          error = "份数最多2份";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did=" + did + " and c2='" + certno + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "身份证号一天内不允许提交2次";
        } else {
          int sum2 = Tools.getIntExcep(jdbc.selectOnlyField("select sum(c4) from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + 
                policy_end + "') and did=" + did + " and c2='" + certno + "'"));
          if (part1 + sum2 > 2)
            error = "投保人已投保了" + sum2 + "份，超出投保上限（2份）"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 0)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(name);
        bean1.setKeepercertno(certno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(0));
        bean1.setC2(tmp_list.get(1));
        bean1.setC3(tmp_list.get(2));
        bean1.setC4(tmp_list.get(3));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_zzrenbao_b(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      int keeper_min = Tools.getIntExcep(dins.getKeeper_min());
      int keeper_max = Tools.getIntExcep(dins.getKeeper_max());
      int part_min = Tools.getIntExcep(dins.getPart_min());
      int part_max = Tools.getIntExcep(dins.getPart_max());
      int part_all = Tools.getIntExcep(dins.getPart_all());
      String did_scope = "did=" + did;
      if (Tools.CheckStr(dins.getPart_other_ins()))
        did_scope = "did in (" + dins.getPart_other_ins() + ")"; 
      int partx = 0;
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String name = trim_all(tmp_list.get(3));
        String certno = tmp_list.get(4);
        String keepername = trim_all(tmp_list.get(1));
        String keepercertno = tmp_list.get(2);
        int part1 = Tools.getIntExcep(tmp_list.get(5));
        partx += part1;
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        String error = "", warning = "";
        int[] el1 = { 1, 2, 3, 4, 5 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!name.equals(keepername) || !certno.equals(keepercertno)) {
          error = "投保人和被保人身份证号必须一致";
        } else if (!Tools.checkAge(keepercertno, keeper_min, keeper_max)) {
          error = "投保人年龄必须 " + keeper_min + "-" + keeper_max + " 周岁";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 2)) {
          error = "投保人在一份数据中不允许重复";
        } else if (part_max == 0 && part1 != part_min) {
          error = "份数必须为" + part_min + "份";
        } else if (part_max > 0 && (part1 < part_min || part1 > part_max)) {
          error = "份数最少" + part_min + "份，最多" + part_max + "份";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did=" + did + " and c4='" + certno + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "被保人一天内不允许提交2次";
        } else {
          int sum2 = Tools.getIntExcep(jdbc.selectOnlyField("select sum(c5) from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and " + did_scope + " and c4='" + certno + "'"));
          if (part1 + sum2 > part_all)
            error = "被保人已投保了" + sum2 + "份，超出投保上限（" + part_all + "份）"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 3)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_zzrenbao_s(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      int name_min = Tools.getIntExcep(dins.getName_min());
      int name_max = Tools.getIntExcep(dins.getName_max());
      int keeper_min = Tools.getIntExcep(dins.getKeeper_min());
      int keeper_max = Tools.getIntExcep(dins.getKeeper_max());
      int part_min = Tools.getIntExcep(dins.getPart_min());
      int part_max = Tools.getIntExcep(dins.getPart_max());
      int part_all = Tools.getIntExcep(dins.getPart_all());
      String did_scope = "did=" + did;
      if (Tools.CheckStr(dins.getPart_other_ins()))
        did_scope = "did in (" + dins.getPart_other_ins() + ")"; 
      int partx = 0;
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String name = trim_all(tmp_list.get(3));
        String certno = tmp_list.get(4);
        String keepername = trim_all(tmp_list.get(1));
        String keepercertno = tmp_list.get(2);
        int part1 = Tools.getIntExcep(tmp_list.get(5));
        partx += part1;
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        String error = "", warning = "";
        int[] el1 = { 1, 2, 3, 4, 5 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (name.equals(keepername) || certno.equals(keepercertno)) {
          error = "投保人和被保人姓名、身份证号必须不一致";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 1, 2)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (!Tools.checkAge(keepercertno, keeper_min, keeper_max)) {
          error = "投保人年龄必须大于" + keeper_min + "周岁";
        } else if (!Tools.checkAge(certno, name_min, name_max)) {
          error = "被保人年龄必须 " + name_min + "-" + name_max + " 周岁";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 4)) {
          error = "的被保人在一份数据中不允许重复";
        } else if (part_max == 0 && part1 != part_min) {
          error = "份数必须为" + part_min + "份";
        } else if (part_max > 0 && (part1 < part_min || part1 > part_max)) {
          error = "份数最少" + part_min + "份，最多" + part_max + "份";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did=" + did + " and c4='" + certno + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "被保人一天内不允许提交2次";
        } else {
          int sum2 = Tools.getIntExcep(jdbc.selectOnlyField("select sum(c5) from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + 
                policy_end + "') and " + did_scope + " and c4='" + certno + "'"));
          if (part1 + sum2 > part_all)
            error = "被保人已投保了" + sum2 + "份，超出投保上限（" + part_all + "份）"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 3)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_yinlingak(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      int partx = 0;
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String name = trim_all(tmp_list.get(1));
        String certno = tmp_list.get(3);
        String keepername = trim_all(tmp_list.get(7));
        String keepercertno = "";
        String birthday1 = tmp_list.get(4);
        String sex1 = tmp_list.get(5);
        String tel = tmp_list.get(6);
        if (Tools.isCard(certno)) {
          certno = certno.toLowerCase();
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(4, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(5, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人生日错误或格式不对";
          } 
        } 
        int tmp_part = Tools.getIntExcep(tmp_list.get(8));
        partx += tmp_part;
        int[] el1 = { 1, 2, 3, 4, 5, 8 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!Tools.checkAge(certno, 60, 80)) {
          error = "投保人年龄必须 60-80 周岁";
        } else if (SysTools.checkBlack(error, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (!name.equals(keepername)) {
          error = "投保人与被保人必须是同一人";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人或投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 3)) {
          error = "被保人在一份数据中不允许重复";
        } else if (Tools.CheckStr(tel) && !isTel(tel)) {
          error = "手机号错误";
        } else if (tmp_part < 1 || tmp_part > 2) {
          error = "的份数最多2份";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did=" + did + " and c3='" + certno + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "被保人一天内不允许提交2次";
        } else {
          int sum2 = Tools.getIntExcep(jdbc.selectOnlyField("select sum(c8) from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + 
                policy_end + "') and did=" + did + " and c3='" + certno + "'"));
          if (tmp_part + sum2 > 2)
            error = "被保人已投保了" + sum2 + "份，超出投保上限（2份）"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 1)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_gslaonian(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Object>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Object> tmp_row = new ArrayList();
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      int take_size = Tools.getIntExcep(dins.getTake_size());
      String name_min = dins.getName_min();
      String name_max = dins.getName_max();
      String keeper_min = dins.getKeeper_min();
      String keeper_max = dins.getKeeper_max();
      int part_all = Tools.getIntExcep(dins.getPart_all());
      String did_scope = "did=" + did;
      if (Tools.CheckStr(dins.getPart_other_ins()))
        did_scope = "did in (" + dins.getPart_other_ins() + ")"; 
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      int partx = 0;
      ArrayList<DataPostListBean> post_list = new ArrayList();
      ArrayList result_list1 = jdbc.selectList("select certno from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') " + 
          "and did=" + did + " and post_dt like '" + Tools.getCurrentDate() + "%'");
      DataPostListBean beanx = new DataPostListBean();
      beanx.setDid(dins.getId());
      ArrayList result_list2 = jdbc.selectList("select certno," + beanx.getDataPart() + "*part from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and " + did_scope, 2);
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String name = trim_all(tmp_list.get(0));
        String certno = tmp_list.get(1);
        String keepername = trim_all(tmp_list.get(5));
        String keepercertno = tmp_list.get(7);
        String guanxi = tmp_list.get(4);
        String ins_name = tmp_list.get(11);
        partx++;
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        String birthday1 = tmp_list.get(2);
        String sex1 = tmp_list.get(3);
        String sex2 = tmp_list.get(6);
        if (Tools.isCard(certno)) {
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(2, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(3, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(6, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人性别错误";
          } 
          String tmp_sheng = NativePlace.getSheng(keepercertno);
          tmp_list.set(10, tmp_sheng);
        } 
        int[] el1 = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (guanxi.indexOf("本人") == -1) {
          error = "与被保险人关系不是本人";
        } else if (!name.equals(keepername) || !certno.equals(keepercertno)) {
          error = "投保人与被保人不一致";
        } else if (!checkAge(certno, name_min, name_max)) {
          error = "被保人年龄必须 " + getLimitStr(name_min) + "-" + getLimitStr(name_max);
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 1)) {
          error = "被保人在一份数据中不允许重复";
        } else if (!ins_name.equals("国寿老年意外险E款100方案") && did.equals("107")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("老年意外险100方案") && did.equals("25")) {
          error = "投保险种错误";
        } else if (!ins_name.equals("37") && did.equals("76")) {
          error = "投保险种错误";
        } else if (!ins_name.equals("4") && did.equals("77")) {
          error = "投保险种错误";
        } else if (isTake(certno, result_list1)) {
          error = "被保人一天内不允许提交2次";
        } else {
          int[] int_arr = getResultSum(certno, result_list2);
          if (1 + int_arr[1] > part_all)
            error = "被保人已投保了" + int_arr[1] + "份，超出投保上限（" + part_all + "份）"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 0)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(0));
        bean1.setC2(tmp_list.get(1));
        bean1.setC3(tmp_list.get(2));
        bean1.setC4(tmp_list.get(3));
        bean1.setC5(tmp_list.get(4));
        bean1.setC6(tmp_list.get(5));
        bean1.setC7(tmp_list.get(6));
        bean1.setC8(tmp_list.get(7));
        bean1.setC9(tmp_list.get(8));
        bean1.setC10(tmp_list.get(9));
        bean1.setC11(tmp_list.get(10));
        bean1.setC12(tmp_list.get(11));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_pa_nocard_bao(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String ins_name = tmp_list.get(1);
        String email = tmp_list.get(13);
        String name = trim_all(tmp_list.get(19));
        String certno = tmp_list.get(21);
        String keepername = trim_all(tmp_list.get(2));
        String keepercertno = trim_all(tmp_list.get(5));
        String keeperteltype = tmp_list.get(6);
        String keepertel = tmp_list.get(7);
        String keepertel2 = tmp_list.get(23);
        String certtype1 = tmp_list.get(4);
        String certtype2 = tmp_list.get(20);
        String cartype = tmp_list.get(31);
        String factory = tmp_list.get(14);
        String card_num1 = tmp_list.get(15);
        String card_num2 = tmp_list.get(17);
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        String leixing1 = tmp_list.get(3);
        String leixing2 = tmp_list.get(18);
        String sex1 = tmp_list.get(24);
        String birthday1 = tmp_list.get(25);
        String sex2 = tmp_list.get(8);
        String birthday2 = tmp_list.get(9);
        int days = 0;
        if (Tools.isCard(certno)) {
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          days = Tools.differentDays(tmp_birthday1, Tools.getDate());
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(25, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(24, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(9, tmp_birthday2);
            warning = "投保人生日错误";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(8, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人性别错误";
          } 
        } 
        int[] el1 = { 
            1, 2, 3, 4, 5, 6, 7, 13, 14, 15, 
            17, 18, 19, 20, 21, 22, 23, 31 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("方案一") && did.equals("96")) {
          error = "投保方案错误";
        } else if (!certtype1.equals("身份证") || !certtype2.equals("身份证")) {
          error = "证件类型必须为身份证";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!cartype.equals("两轮") && !cartype.equals("三轮")) {
          error = "车辆类型必须为两轮或者三轮";
        } else if (!Tools.CheckStr(keeperteltype) || !keeperteltype.equals("手机")) {
          error = "投保人联系方式类型错误";
        } else if (!Tools.CheckStr(keepertel) || !Tools.isTel(keepertel)) {
          error = "投保人联系方式错误";
        } else if (!Tools.CheckStr(keepertel2) || !Tools.isTel(keepertel2)) {
          error = "被保人联系方式错误";
        } else if (!Tools.isEmail(email)) {
          error = "投保人邮箱错误";
        } else if (!leixing1.equals("个人") || !leixing2.equals("个人")) {
          error = "类型必须是个人";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 21)) {
          error = "被保人证件号重复，被保人限购一份";
        } else if (isValueRepeat(j, card_num1, rowList, 15)) {
          error = "电动机号重复，限购一份";
        } else if (isValueRepeat(j, card_num2, rowList, 17)) {
          error = "车架号重复，限购一份";
        } else if (!name.equals(keepername) || !certno.equals(keepercertno)) {
          error = "投保人与被保人必须一致";
        } else if (!Tools.checkAge(keepercertno, 18, 65)) {
          error = "投保人年龄必须18-65周岁";
        } else if (!isLetterDigitOrChinese(factory)) {
          error = "厂牌型号限必须汉字、字母、数字";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and did in (" + did + ") and certno='" + certno + "'")) {
          error = "被保人已达到投保上限(1份)，无法继续投保";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and did in (" + did + ") and c15='" + card_num1 + "'")) {
          error = "电动机号已达到投保上限(1份)，无法继续投保";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and did in (" + did + ") and c17='" + card_num2 + "'")) {
          error = "车架号已达到投保上限(1份)，无法继续投保";
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 19)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        bean1.setC12(tmp_list.get(12));
        bean1.setC13(tmp_list.get(13));
        bean1.setC14(tmp_list.get(14));
        bean1.setC15(tmp_list.get(15));
        bean1.setC16(tmp_list.get(16));
        bean1.setC17(tmp_list.get(17));
        bean1.setC18(tmp_list.get(18));
        bean1.setC19(tmp_list.get(19));
        bean1.setC20(tmp_list.get(20));
        bean1.setC21(tmp_list.get(21));
        bean1.setC22(tmp_list.get(22));
        bean1.setC23(tmp_list.get(23));
        bean1.setC24(tmp_list.get(24));
        bean1.setC25(tmp_list.get(25));
        bean1.setC26(tmp_list.get(26));
        bean1.setC27(tmp_list.get(27));
        bean1.setC28(tmp_list.get(28));
        bean1.setC29(tmp_list.get(29));
        bean1.setC30(tmp_list.get(30));
        bean1.setC31(tmp_list.get(31));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_pa_child_ydtdb(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      String dids = "93,94,95";
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String ins_name = tmp_list.get(1);
        String email = tmp_list.get(13);
        String name = trim_all(tmp_list.get(14));
        String certno = tmp_list.get(17);
        String keepername = trim_all(tmp_list.get(2));
        String keepercertno = tmp_list.get(5);
        String keeperteltype = tmp_list.get(6);
        String keepertel = tmp_list.get(7);
        String certtype1 = tmp_list.get(4);
        String certtype2 = tmp_list.get(16);
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        String guanxi = tmp_list.get(29);
        String leixing = tmp_list.get(3);
        String shuxing = tmp_list.get(15);
        String sex1 = tmp_list.get(21);
        String birthday1 = tmp_list.get(20);
        String sex2 = tmp_list.get(8);
        String birthday2 = tmp_list.get(9);
        int days = 0;
        if (Tools.isCard(certno)) {
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          days = Tools.differentDays(tmp_birthday1, Tools.getDate());
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(20, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(21, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
          String tmp_sheng = NativePlace.getSheng(certno);
          tmp_list.set(24, tmp_sheng);
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(9, tmp_birthday2);
            warning = "投保人生日错误";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(8, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人性别错误";
          } 
        } 
        int[] el1 = { 
            1, 2, 3, 4, 5, 6, 7, 13, 14, 15, 
            16, 17, 20, 21, 24, 25, 26, 27, 28, 29 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("方案一") && did.equals("93")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案二") && did.equals("94")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案三") && did.equals("95")) {
          error = "投保方案错误";
        } else if (!certtype1.equals("身份证") || !certtype2.equals("身份证")) {
          error = "证件类型必须为身份证";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!Tools.CheckStr(keeperteltype) || !keeperteltype.equals("手机")) {
          error = "投保人联系方式类型错误";
        } else if (!Tools.CheckStr(keepertel) || !Tools.isTel(keepertel)) {
          error = "投保人联系方式错误";
        } else if (!Tools.isEmail(email)) {
          error = "投保人邮箱错误";
        } else if (!guanxi.equals("子女")) {
          error = "与被保险人关系必须是子女";
        } else if (!leixing.equals("个人")) {
          error = "投保人类型必须是个人";
        } else if (!shuxing.equals("真实被保人")) {
          error = "被保险属性必须是真实被保人";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 17)) {
          error = "被保人证件号重复，被保人限购一份";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 2, 5)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (name.equals(keepername) || certno.equals(keepercertno)) {
          error = "投保人与被保人的姓名、证件号必须不一致";
        } else if (!Tools.checkAge(keepercertno, 18, 200)) {
          error = "投保人年龄必须大于18周岁";
        } else if (Tools.IsInArray("93,94,95".split(","), did) && !Tools.checkAge(certno, 0, 17)) {
          error = "被保人年龄必须 0-17周岁";
        } else if (days <= 30) {
          error = "被保人年龄必须大于30天";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and " + 
            "did in (" + dids + ") and c17='" + certno + "'")) {
          error = "被保人已达到投保上限(1份)，无法继续投保";
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 14)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        bean1.setC12(tmp_list.get(12));
        bean1.setC13(tmp_list.get(13));
        bean1.setC14(tmp_list.get(14));
        bean1.setC15(tmp_list.get(15));
        bean1.setC16(tmp_list.get(16));
        bean1.setC17(tmp_list.get(17));
        bean1.setC18(tmp_list.get(18));
        bean1.setC19(tmp_list.get(19));
        bean1.setC20(tmp_list.get(20));
        bean1.setC21(tmp_list.get(21));
        bean1.setC22(tmp_list.get(22));
        bean1.setC23(tmp_list.get(23));
        bean1.setC24(tmp_list.get(24));
        bean1.setC25(tmp_list.get(25));
        bean1.setC26(tmp_list.get(26));
        bean1.setC27(tmp_list.get(27));
        bean1.setC28(tmp_list.get(28));
        bean1.setC29(tmp_list.get(29));
        bean1.setC30(tmp_list.get(30));
        bean1.setC31(tmp_list.get(31));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_pa_child_jqtdb(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      String dids = "78,79,80";
      if (Tools.IsInArray("81,82".split(","), did))
        dids = "81,82"; 
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String ins_name = tmp_list.get(1);
        String email = tmp_list.get(13);
        String name = trim_all(tmp_list.get(14));
        String certno = tmp_list.get(17);
        String keepername = trim_all(tmp_list.get(2));
        String keepercertno = tmp_list.get(5);
        String keeperteltype = tmp_list.get(6);
        String keepertel = tmp_list.get(7);
        String certtype1 = tmp_list.get(4);
        String certtype2 = tmp_list.get(16);
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        String guanxi = tmp_list.get(29);
        String leixing = tmp_list.get(3);
        String shuxing = tmp_list.get(15);
        String sex1 = tmp_list.get(21);
        String birthday1 = tmp_list.get(20);
        String sex2 = tmp_list.get(8);
        String birthday2 = tmp_list.get(9);
        int days = 0;
        if (Tools.isCard(certno)) {
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          days = Tools.differentDays(tmp_birthday1, Tools.getDate());
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(20, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(21, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
          String tmp_sheng = NativePlace.getSheng(certno);
          tmp_list.set(24, tmp_sheng);
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(9, tmp_birthday2);
            warning = "投保人生日错误";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(8, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人性别错误";
          } 
        } 
        int[] el1 = { 
            1, 2, 3, 4, 5, 6, 7, 13, 14, 15, 
            16, 17, 20, 21, 24, 25, 26, 27, 28, 29 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("方案一") && did.equals("78")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案二") && did.equals("79")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案三") && did.equals("80")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案一") && did.equals("81")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案二") && did.equals("82")) {
          error = "投保方案错误";
        } else if (!certtype1.equals("身份证") || !certtype2.equals("身份证")) {
          error = "证件类型必须为身份证";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!Tools.CheckStr(keeperteltype) || !keeperteltype.equals("手机")) {
          error = "投保人联系方式类型错误";
        } else if (!Tools.CheckStr(keepertel) || !Tools.isTel(keepertel)) {
          error = "投保人联系方式错误";
        } else if (!Tools.isEmail(email)) {
          error = "投保人邮箱错误";
        } else if (!guanxi.equals("子女")) {
          error = "与被保险人关系必须是子女";
        } else if (!leixing.equals("个人")) {
          error = "投保人类型必须是个人";
        } else if (!shuxing.equals("真实被保人")) {
          error = "被保险属性必须是真实被保人";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 17)) {
          error = "被保人证件号重复，被保人限购一份";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 2, 5)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (name.equals(keepername) || certno.equals(keepercertno)) {
          error = "投保人与被保人的姓名、证件号必须不一致";
        } else if (!Tools.checkAge(keepercertno, 18, 200)) {
          error = "投保人年龄必须大于18周岁";
        } else if (Tools.IsInArray("78,79,80".split(","), did) && !Tools.checkAge(certno, 0, 17)) {
          error = "被保人年龄必须 0-17周岁";
        } else if (Tools.IsInArray("81,82".split(","), did) && !Tools.checkAge(certno, 6, 25)) {
          error = "被保人年龄必须 6-25周岁";
        } else if (days <= 30) {
          error = "被保人年龄必须大于30天";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and " + 
            "did in (" + dids + ") and c17='" + certno + "'")) {
          error = "被保人已达到投保上限(1份)，无法继续投保";
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 14)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        bean1.setC12(tmp_list.get(12));
        bean1.setC13(tmp_list.get(13));
        bean1.setC14(tmp_list.get(14));
        bean1.setC15(tmp_list.get(15));
        bean1.setC16(tmp_list.get(16));
        bean1.setC17(tmp_list.get(17));
        bean1.setC18(tmp_list.get(18));
        bean1.setC19(tmp_list.get(19));
        bean1.setC20(tmp_list.get(20));
        bean1.setC21(tmp_list.get(21));
        bean1.setC22(tmp_list.get(22));
        bean1.setC23(tmp_list.get(23));
        bean1.setC24(tmp_list.get(24));
        bean1.setC25(tmp_list.get(25));
        bean1.setC26(tmp_list.get(26));
        bean1.setC27(tmp_list.get(27));
        bean1.setC28(tmp_list.get(28));
        bean1.setC29(tmp_list.get(29));
        bean1.setC30(tmp_list.get(30));
        bean1.setC31(tmp_list.get(31));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_et_fun1(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      int take_size = Tools.getIntExcep(dins.getTake_size());
      String name_min = dins.getName_min();
      String name_max = dins.getName_max();
      String keeper_min = dins.getKeeper_min();
      String keeper_max = dins.getKeeper_max();
      int part_all = Tools.getIntExcep(dins.getPart_all());
      String did_scope = "did=" + did;
      if (Tools.CheckStr(dins.getPart_other_ins()))
        did_scope = "did in (" + dins.getPart_other_ins() + ")"; 
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      ArrayList result_list1 = jdbc.selectList("select certno from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') " + 
          "and did=" + did + " and post_dt like '" + Tools.getCurrentDate() + "%'");
      DataPostListBean beanx = new DataPostListBean();
      beanx.setDid(dins.getId());
      ArrayList result_list2 = jdbc.selectList("select certno," + beanx.getDataPart() + "*part from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and " + did_scope, 2);
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String ins_name = tmp_list.get(1);
        String email = tmp_list.get(13);
        String name = trim_all(tmp_list.get(14));
        String certno = tmp_list.get(17);
        String keepername = trim_all(tmp_list.get(2));
        String keepercertno = tmp_list.get(5);
        String keeperteltype = tmp_list.get(6);
        String keepertel = tmp_list.get(7);
        String certtype1 = tmp_list.get(4);
        String certtype2 = tmp_list.get(16);
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        String guanxi = tmp_list.get(29);
        String leixing = tmp_list.get(3);
        String shuxing = tmp_list.get(15);
        String sex1 = tmp_list.get(21);
        String birthday1 = tmp_list.get(20);
        String sex2 = tmp_list.get(8);
        String birthday2 = tmp_list.get(9);
        int tmp_age1 = 0;
        if (Tools.isCard(certno)) {
          tmp_age1 = Tools.getAgex(certno);
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(20, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(21, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
          String tmp_sheng = NativePlace.getSheng(certno);
          tmp_list.set(24, tmp_sheng);
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(9, tmp_birthday2);
            warning = "投保人生日错误";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(8, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人性别错误";
          } 
        } 
        int[] el1 = { 
            1, 2, 3, 4, 5, 6, 7, 13, 14, 15, 
            16, 17, 20, 21, 24, 25, 26, 27, 28, 29 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("方案一") && (did.equals("61") || did.equals("93") || did.equals("78") || 
          did.equals("118") || did.equals("154") || did.equals("162") || did.equals("143") || 
          did.equals("131") || did.equals("134") || did.equals("125") || did.equals("177") || 
          did.equals("189") || did.equals("192") || did.equals("221") || did.equals("81") || 
          did.equals("227") || did.equals("232"))) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案二") && (did.equals("62") || did.equals("94") || did.equals("79") || 
          did.equals("119") || did.equals("155") || did.equals("163") || did.equals("144") || 
          did.equals("132") || did.equals("135") || did.equals("126") || did.equals("178") || 
          did.equals("190") || did.equals("193") || did.equals("222") || did.equals("82") || 
          did.equals("228") || did.equals("233"))) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案三") && (did.equals("63") || did.equals("95") || did.equals("80") || 
          did.equals("120") || did.equals("156") || did.equals("164") || did.equals("145") || 
          did.equals("133") || did.equals("136") || did.equals("142") || did.equals("179") || 
          did.equals("127") || did.equals("191") || did.equals("194") || did.equals("223") || 
          did.equals("229") || did.equals("234"))) {
          error = "投保方案错误";
        } else if (!ins_name.equals("学生版意外5+0.3") && did.equals("168")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("学生版意外8+1") && did.equals("169")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("学生版3+0.3+3+1") && did.equals("202")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("学生版3+0.3+3+1") && did.equals("211")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("平安学生互联网版3+1+6") && did.equals("218")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("平安学生互联网版5+1.5+8") && did.equals("219")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("平安学生互联网版10+2+12") && did.equals("220")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("平安学生阶段赔付款5+0.5+8") && did.equals("231")) {
          error = "投保方案错误";
        } else if (!certtype1.equals("身份证") || !certtype2.equals("身份证")) {
          error = "证件类型必须为身份证";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!Tools.CheckStr(keeperteltype) || !keeperteltype.equals("手机")) {
          error = "投保人联系方式类型错误";
        } else if (!Tools.CheckStr(keepertel) || !Tools.isTel(keepertel)) {
          error = "投保人联系方式错误";
        } else if (!Tools.isEmail(email)) {
          error = "投保人邮箱错误";
        } else if (Tools.IsInArray("81,82,168,169,189,190,191,202,211,218,219,220,221,222,223,231,232,233,234".split(","), did) && tmp_age1 < 18 && !guanxi.equals("子女")) {
          error = ".与被保险人关系必须是子女";
        } else if (Tools.IsInArray("81,82,168,169,189,190,191,202,211,218,219,220,221,222,223,231,232,233,234".split(","), did) && tmp_age1 >= 18 && !guanxi.equals("本人")) {
          error = "与被保险人关系必须是本人";
        } else if (Tools.IsInArray("81,82,168,169,189,190,191,202,211,218,219,220,221,222,223,231,232,233,234".split(","), did) && tmp_age1 >= 18 && (!name.equals(keepername) || !certno.equals(keepercertno))) {
          error = "投保人与被保人的姓名、证件号必须一致";
        } else if (Tools.IsInArray("81,82,168,169,189,190,191,202,211,218,219,220,221,222,223,231,232,233,234".split(","), did) && tmp_age1 < 18 && (name.equals(keepername) || certno.equals(keepercertno))) {
          error = "投保人与被保人的姓名、证件号必须不一致";
        } else if (!Tools.IsInArray("81,82,168,169,189,190,191,202,211,218,219,220,221,222,223,231,232,233,234".split(","), did) && !guanxi.equals("子女")) {
          error = "与被保险人关系必须是子女.";
        } else if (!Tools.IsInArray("81,82,168,169,189,190,191,202,211,218,219,220,221,222,223,231,232,233,234".split(","), did) && (name.equals(keepername) || certno.equals(keepercertno))) {
          error = "与被保险人关系必须是子女";
        } else if (!leixing.equals("个人")) {
          error = "投保人类型必须是个人";
        } else if (!shuxing.equals("真实被保人")) {
          error = "被保险属性必须是真实被保人";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 17)) {
          error = "被保人证件号重复，被保人限购一份";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 2, 5)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (!checkAge(keepercertno, keeper_min, keeper_max)) {
          error = "投保人年龄必须 " + getLimitStr(keeper_min) + "-" + getLimitStr(keeper_max);
        } else if (!checkAge(certno, name_min, name_max)) {
          error = "被保人年龄必须 " + getLimitStr(name_min) + "-" + getLimitStr(name_max);
        } else if (isTake(certno, result_list1)) {
          error = "被保人一天内不允许提交2次";
        } else {
          int[] int_arr = getResultSum(certno, result_list2);
          if (take_size > 0 && int_arr[0] >= take_size)
            error = "被保人超出投保次数（" + take_size + "次）"; 
          if (1 + int_arr[1] > part_all)
            error = "被保人已投保了" + int_arr[1] + "份，超出投保上限（" + part_all + "份）"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 14)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        bean1.setC12(tmp_list.get(12));
        bean1.setC13(tmp_list.get(13));
        bean1.setC14(tmp_list.get(14));
        bean1.setC15(tmp_list.get(15));
        bean1.setC16(tmp_list.get(16));
        bean1.setC17(tmp_list.get(17));
        bean1.setC18(tmp_list.get(18));
        bean1.setC19(tmp_list.get(19));
        bean1.setC20(tmp_list.get(20));
        bean1.setC21(tmp_list.get(21));
        bean1.setC22(tmp_list.get(22));
        bean1.setC23(tmp_list.get(23));
        bean1.setC24(tmp_list.get(24));
        bean1.setC25(tmp_list.get(25));
        bean1.setC26(tmp_list.get(26));
        bean1.setC27(tmp_list.get(27));
        bean1.setC28(tmp_list.get(28));
        bean1.setC29(tmp_list.get(29));
        bean1.setC30(tmp_list.get(30));
        bean1.setC31(tmp_list.get(31));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_pa_child_jqb1(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String ins_name = tmp_list.get(1);
        String email = tmp_list.get(13);
        String name = trim_all(tmp_list.get(14));
        String certno = tmp_list.get(17);
        String keepername = trim_all(tmp_list.get(2));
        String keepercertno = tmp_list.get(5);
        String keeperteltype = tmp_list.get(6);
        String keepertel = tmp_list.get(7);
        String certtype1 = tmp_list.get(4);
        String certtype2 = tmp_list.get(16);
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        String guanxi = tmp_list.get(29);
        String leixing = tmp_list.get(3);
        String shuxing = tmp_list.get(15);
        String sex1 = tmp_list.get(21);
        String birthday1 = tmp_list.get(20);
        String sex2 = tmp_list.get(8);
        String birthday2 = tmp_list.get(9);
        int days = 0;
        if (Tools.isCard(certno)) {
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          days = Tools.differentDays(tmp_birthday1, Tools.getDate());
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(20, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(21, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
          String tmp_sheng = NativePlace.getSheng(certno);
          tmp_list.set(24, tmp_sheng);
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(9, tmp_birthday2);
            warning = "投保人生日错误";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(8, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人性别错误";
          } 
        } 
        int[] el1 = { 
            1, 2, 3, 4, 5, 6, 7, 13, 14, 15, 
            16, 17, 20, 21, 24, 26, 27, 28, 29 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("方案一") && did.equals("61")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案二") && did.equals("62")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案三") && did.equals("63")) {
          error = "投保方案错误";
        } else if (!certtype1.equals("身份证") || !certtype2.equals("身份证")) {
          error = "证件类型必须为身份证";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!Tools.CheckStr(keeperteltype) || !keeperteltype.equals("手机")) {
          error = "投保人联系方式类型错误";
        } else if (!Tools.CheckStr(keepertel) || !Tools.isTel(keepertel)) {
          error = "投保人联系方式错误";
        } else if (!Tools.isEmail(email)) {
          error = "投保人邮箱错误";
        } else if (!guanxi.equals("子女")) {
          error = "与被保险人关系必须是子女";
        } else if (!leixing.equals("个人")) {
          error = "投保人类型必须是个人";
        } else if (!shuxing.equals("真实被保人")) {
          error = "被保险属性必须是真实被保人";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 17)) {
          error = "被保人证件号重复，被保人限购一份";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 2, 5)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (name.equals(keepername) || certno.equals(keepercertno)) {
          error = "投保人与被保人的姓名、证件号必须不一致";
        } else if (!Tools.checkAge(keepercertno, 18, 200)) {
          error = "投保人年龄必须大于18周岁";
        } else if (!Tools.checkAge(certno, 0, 17)) {
          error = "被保人年龄必须 0-17周岁";
        } else if (days <= 30) {
          error = "被保人年龄必须大于30天";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and " + 
            "did in (" + "61,62,63" + ") and c17='" + certno + "'")) {
          error = "被保人已达到投保上限(1份)，无法继续投保";
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 14)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        bean1.setC12(tmp_list.get(12));
        bean1.setC13(tmp_list.get(13));
        bean1.setC14(tmp_list.get(14));
        bean1.setC15(tmp_list.get(15));
        bean1.setC16(tmp_list.get(16));
        bean1.setC17(tmp_list.get(17));
        bean1.setC18(tmp_list.get(18));
        bean1.setC19(tmp_list.get(19));
        bean1.setC20(tmp_list.get(20));
        bean1.setC21(tmp_list.get(21));
        bean1.setC22(tmp_list.get(22));
        bean1.setC23(tmp_list.get(23));
        bean1.setC24(tmp_list.get(24));
        bean1.setC25(tmp_list.get(25));
        bean1.setC26(tmp_list.get(26));
        bean1.setC27(tmp_list.get(27));
        bean1.setC28(tmp_list.get(28));
        bean1.setC29(tmp_list.get(29));
        bean1.setC30(tmp_list.get(30));
        bean1.setC31(tmp_list.get(31));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_ertong(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String ins_name = tmp_list.get(1);
        String email = tmp_list.get(13);
        String name = trim_all(tmp_list.get(14));
        String certno = tmp_list.get(17);
        String keepername = trim_all(tmp_list.get(2));
        String keepercertno = tmp_list.get(5);
        String keeperteltype = tmp_list.get(6);
        String keepertel = tmp_list.get(7);
        String certtype1 = tmp_list.get(4);
        String certtype2 = tmp_list.get(16);
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        String guanxi = tmp_list.get(29);
        String leixing = tmp_list.get(3);
        String shuxing = tmp_list.get(15);
        String sex1 = tmp_list.get(21);
        String birthday1 = tmp_list.get(20);
        String sex2 = tmp_list.get(8);
        String birthday2 = tmp_list.get(9);
        int days = 0;
        if (Tools.isCard(certno)) {
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          days = Tools.differentDays(tmp_birthday1, Tools.getDate());
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(20, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(21, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
          String tmp_sheng = NativePlace.getSheng(certno);
          tmp_list.set(24, tmp_sheng);
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(9, tmp_birthday2);
            warning = "投保人生日错误";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(8, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人性别错误";
          } 
        } 
        int[] el1 = { 
            1, 2, 3, 4, 5, 6, 7, 13, 14, 15, 
            16, 17, 20, 21, 24, 25, 26, 27, 28, 29 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("方案一") && (did.equals("11") || did.equals("14"))) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案二") && (did.equals("12") || did.equals("15"))) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案三") && (did.equals("13") || did.equals("16"))) {
          error = "投保方案错误";
        } else if (!certtype1.equals("身份证") || !certtype2.equals("身份证")) {
          error = "证件类型必须为身份证";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!Tools.CheckStr(keeperteltype) || !keeperteltype.equals("手机")) {
          error = "投保人联系方式类型错误";
        } else if (!Tools.CheckStr(keepertel) || !Tools.isTel(keepertel)) {
          error = "投保人联系方式错误";
        } else if (!Tools.isEmail(email)) {
          error = "投保人邮箱错误";
        } else if (!guanxi.equals("子女")) {
          error = "与被保险人关系必须是子女";
        } else if (!leixing.equals("个人")) {
          error = "投保人类型必须是个人";
        } else if (!shuxing.equals("真实被保人")) {
          error = "被保险属性必须是真实被保人";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 17)) {
          error = "被保人证件号重复，被保人限购一份";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 2, 5)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (name.equals(keepername) || certno.equals(keepercertno)) {
          error = "投保人与被保人的姓名、证件号必须不一致";
        } else if (!Tools.checkAge(keepercertno, 18, 200)) {
          error = "投保人年龄必须大于18周岁";
        } else if (!Tools.checkAge(certno, 0, 17)) {
          error = "被保人年龄必须 0-17周岁";
        } else if (days <= 30) {
          error = "被保人年龄必须大于30天";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and " + 
            "did in (" + "11,12,13,14,15,16" + ") and certno='" + certno + "'")) {
          error = "被保人已达到投保上限(1份)，无法继续投保";
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 14)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        bean1.setC12(tmp_list.get(12));
        bean1.setC13(tmp_list.get(13));
        bean1.setC14(tmp_list.get(14));
        bean1.setC15(tmp_list.get(15));
        bean1.setC16(tmp_list.get(16));
        bean1.setC17(tmp_list.get(17));
        bean1.setC18(tmp_list.get(18));
        bean1.setC19(tmp_list.get(19));
        bean1.setC20(tmp_list.get(20));
        bean1.setC21(tmp_list.get(21));
        bean1.setC22(tmp_list.get(22));
        bean1.setC23(tmp_list.get(23));
        bean1.setC24(tmp_list.get(24));
        bean1.setC25(tmp_list.get(25));
        bean1.setC26(tmp_list.get(26));
        bean1.setC27(tmp_list.get(27));
        bean1.setC28(tmp_list.get(28));
        bean1.setC29(tmp_list.get(29));
        bean1.setC30(tmp_list.get(30));
        bean1.setC31(tmp_list.get(31));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_ayrenbao(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      int partx = 0;
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String ins_name = tmp_list.get(1);
        String name = trim_all(tmp_list.get(2));
        String certno = tmp_list.get(3);
        String keepername = trim_all(tmp_list.get(4));
        String keepercertno = tmp_list.get(5);
        String age1 = tmp_list.get(8);
        int tmp_part = Tools.getIntExcep(tmp_list.get(7));
        partx += tmp_part;
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        if (Tools.isCard(certno)) {
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_age1 = (String)tmp_map1.get("age");
          if (!age1.equals(tmp_age1)) {
            tmp_list.set(8, tmp_age1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人年龄错误";
          } 
        } 
        int[] el1 = { 1, 2, 3, 4, 5, 6, 7, 8 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("河南人保10+1+50（1-6）") && did.equals("22")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("河南人保10+2+50（1-6）") && did.equals("23")) {
          error = "投保方案错误";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!certno.equals(keepercertno) || !name.equals(keepername)) {
          error = "投保人与被保人必须一致";
        } else if (!Tools.checkAge(keepercertno, 18, 65)) {
          error = "投保人年龄必须 18-65 周岁";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 3)) {
          error = "被保人在一份数据中不允许重复";
        } else if (tmp_part < 1 || tmp_part > 3) {
          error = "份数最多3份";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did=" + did + " and c3='" + certno + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "被保人一天内不允许提交2次";
        } else {
          int sum2 = Tools.getIntExcep(jdbc.selectOnlyField("select sum(c7) from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + 
                policy_end + "') and did in (" + "22,23" + ") and c3='" + certno + "'"));
          if (tmp_part + sum2 > 2)
            error = "投保人已投保了" + sum2 + "份，超出投保上限（2份）"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 2)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, keepername, rowList, 4)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "投保人同名: " + keepername;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(String.valueOf(partx));
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_pa_jcb(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      ArrayList<ArrayList> rowList = getRowList(true, json, row, head);
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      int take_size = Tools.getIntExcep(dins.getTake_size());
      String name_min = dins.getName_min();
      String name_max = dins.getName_max();
      String keeper_min = dins.getKeeper_min();
      String keeper_max = dins.getKeeper_max();
      int part_all = Tools.getIntExcep(dins.getPart_all());
      String did_scope = "did=" + did;
      if (Tools.CheckStr(dins.getPart_other_ins()))
        did_scope = "did in (" + dins.getPart_other_ins() + ")"; 
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int i = 0; i < rowList.size(); i++) {
        ArrayList<String> tmp_list = rowList.get(i);
        String error = "", warning = "";
        String ins_name = tmp_list.get(1);
        String email = tmp_list.get(13);
        String name = trim_all(tmp_list.get(18));
        String certno = tmp_list.get(20);
        String keepername = trim_all(tmp_list.get(2));
        String keepercertno = tmp_list.get(5);
        String keepertel = tmp_list.get(7);
        String address = tmp_list.get(14);
        String build = tmp_list.get(15);
        String certtype1 = tmp_list.get(4);
        String certtype2 = tmp_list.get(19);
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        String leixing1 = tmp_list.get(3);
        String leixing2 = tmp_list.get(17);
        String sex1 = tmp_list.get(23);
        String birthday1 = tmp_list.get(24);
        String sex2 = tmp_list.get(8);
        String birthday2 = tmp_list.get(9);
        if (Tools.isCard(certno)) {
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(24, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(23, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(9, tmp_birthday2);
            warning = "投保人生日错误或格式不对";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(8, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人性别错误";
          } 
        } 
        int[] el1 = { 
            1, 2, 3, 4, 5, 6, 7, 13, 14, 15, 
            17, 18, 19, 20, 21, 22 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("方案一") && did.equals("101")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案二") && did.equals("102")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案三") && did.equals("103")) {
          error = "投保方案错误";
        } else if (!certtype1.equals("身份证") || !certtype2.equals("身份证")) {
          error = "证件类型必须为身份证";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!Tools.CheckStr(keepertel) || !Tools.isTel(keepertel)) {
          error = "投保人联系方式错误";
        } else if (!build.equals("钢混/砖混结构")) {
          error = "可承保结构仅为“钢混/砖混结构";
        } else if (!Tools.isEmail(email)) {
          error = "投保人邮箱错误";
        } else if (!leixing1.equals("个人") || !leixing2.equals("个人")) {
          error = "投保人类型或被保险人客户类型必须是个人";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(i, address, rowList, 14)) {
          error = "标的地址重复，限购一份";
        } else if (!checkAge(keepercertno, keeper_min, keeper_max)) {
          error = "投保人年龄必须 " + getLimitStr(keeper_min) + "-" + getLimitStr(keeper_max);
        } else if (!checkAge(certno, name_min, name_max)) {
          error = "被保人年龄必须 " + getLimitStr(name_min) + "-" + getLimitStr(name_max);
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and " + 
            "did in (" + "101,102,103" + ") and c14='" + address + "'")) {
          error = "被保人已达到投保上限(1份)，无法继续投保";
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(i));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        bean1.setC12(tmp_list.get(12));
        bean1.setC13(tmp_list.get(13));
        bean1.setC14(tmp_list.get(14));
        bean1.setC15(tmp_list.get(15));
        bean1.setC16(tmp_list.get(16));
        bean1.setC17(tmp_list.get(17));
        bean1.setC18(tmp_list.get(18));
        bean1.setC19(tmp_list.get(19));
        bean1.setC20(tmp_list.get(20));
        bean1.setC21(tmp_list.get(21));
        bean1.setC22(tmp_list.get(22));
        bean1.setC23(tmp_list.get(23));
        bean1.setC24(tmp_list.get(24));
        bean1.setC25(tmp_list.get(25));
        bean1.setC26(tmp_list.get(26));
        bean1.setC27(tmp_list.get(27));
        bean1.setC28(tmp_list.get(28));
        bean1.setC29(tmp_list.get(29));
        bean1.setC30(tmp_list.get(30));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(dins.getPrice());
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_seqjtbb(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String ins_name = tmp_list.get(1);
        String email = tmp_list.get(13);
        String name = trim_all(tmp_list.get(14));
        String certno = tmp_list.get(17);
        String keepername = trim_all(tmp_list.get(2));
        String keepercertno = tmp_list.get(5);
        String keepertel = tmp_list.get(7);
        String certtype1 = tmp_list.get(4);
        String certtype2 = tmp_list.get(16);
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        String guanxi = tmp_list.get(29);
        String leixing = tmp_list.get(3);
        String shuxing = tmp_list.get(15);
        String sex1 = tmp_list.get(21);
        String birthday1 = tmp_list.get(20);
        String sex2 = tmp_list.get(8);
        String birthday2 = tmp_list.get(9);
        if (Tools.isCard(certno)) {
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(20, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(21, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
          String tmp_sheng = NativePlace.getSheng(certno);
          tmp_list.set(24, tmp_sheng);
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(9, tmp_birthday2);
            warning = "投保人生日错误或格式不对";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(8, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人性别错误";
          } 
        } 
        int[] el1 = { 
            1, 2, 3, 5, 6, 7, 13, 14, 15, 16, 
            17, 20, 21, 25, 26, 27, 28, 29 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("方案一") && did.equals("47")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案二") && did.equals("48")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案三") && did.equals("49")) {
          error = "投保方案错误";
        } else if (!certtype1.equals("身份证") || !certtype2.equals("身份证")) {
          error = "证件类型必须为身份证";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!Tools.CheckStr(keepertel) || !Tools.isTel(keepertel)) {
          error = "投保人联系方式错误";
        } else if (!Tools.isEmail(email)) {
          error = "投保人邮箱错误";
        } else if (!guanxi.equals("子女")) {
          error = "与被保险人关系必须是子女";
        } else if (!leixing.equals("个人")) {
          error = "投保人类型必须是个人";
        } else if (!shuxing.equals("真实被保人")) {
          error = "被保险属性必须是真实被保人";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 17)) {
          error = "被保人证件号重复，被保人限购一份";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 2, 5)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (name.equals(keepername) || certno.equals(keepercertno)) {
          error = "投保人与被保人的姓名、证件号必须不一致";
        } else if (!Tools.checkAge(keepercertno, 18, 200)) {
          error = "投保人年龄必须大于18周岁";
        } else if (!Tools.checkAge(certno, 3, 18)) {
          error = "被保人年龄必须 3-18周岁";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and " + 
            "did in (" + "47,48,49" + ") and c17='" + certno + "'")) {
          error = "被保人已达到投保上限(1份)，无法继续投保";
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 14)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        bean1.setC12(tmp_list.get(12));
        bean1.setC13(tmp_list.get(13));
        bean1.setC14(tmp_list.get(14));
        bean1.setC15(tmp_list.get(15));
        bean1.setC16(tmp_list.get(16));
        bean1.setC17(tmp_list.get(17));
        bean1.setC18(tmp_list.get(18));
        bean1.setC19(tmp_list.get(19));
        bean1.setC20(tmp_list.get(20));
        bean1.setC21(tmp_list.get(21));
        bean1.setC22(tmp_list.get(22));
        bean1.setC23(tmp_list.get(23));
        bean1.setC24(tmp_list.get(24));
        bean1.setC25(tmp_list.get(25));
        bean1.setC26(tmp_list.get(26));
        bean1.setC27(tmp_list.get(27));
        bean1.setC28(tmp_list.get(28));
        bean1.setC29(tmp_list.get(29));
        bean1.setC30(tmp_list.get(30));
        bean1.setC31(tmp_list.get(31));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_sijipingan_rx(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      ArrayList<ArrayList> rowList = getRowList(true, json, row, head);
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int i = 0; i < rowList.size(); i++) {
        ArrayList<String> tmp_list = rowList.get(i);
        String error = "", warning = "";
        String name = trim_all(tmp_list.get(1));
        String certno = tmp_list.get(4);
        String keepername = trim_all(tmp_list.get(6));
        String keepercertno = tmp_list.get(9);
        String sex1 = tmp_list.get(2);
        String birthday1 = tmp_list.get(5);
        String sex2 = tmp_list.get(7);
        String birthday2 = tmp_list.get(10);
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        int tmp_age1 = 0;
        if (Tools.isCard(certno)) {
          tmp_age1 = Tools.getAgex(certno);
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday_cn");
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(5, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(2, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday_cn");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(10, tmp_birthday2);
            warning = "投保人生日错误或格式不对";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(7, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人生日性别";
          } 
        } 
        int[] el1 = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (tmp_age1 >= 18 && (!name.equals(keepername) || !certno.equals(keepercertno))) {
          error = "被保人是成年人，投保人与被保人的姓名、证件号必须一致";
        } else if (tmp_age1 < 18 && (name.equals(keepername) || certno.equals(keepercertno))) {
          error = "被保人是未年人，投保人与被保人的姓名、证件号必须不一致";
        } else if (!Tools.checkAge(keepercertno, 18, 65)) {
          error = "投保人年龄必须 18-65周岁";
        } else if (!Tools.checkAge(certno, 1, 65)) {
          error = "被保人年龄必须1-65周岁";
        } else if (isValueRepeat(i, certno, rowList, 4)) {
          error = "被保人在一份数据中不允许重复";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did=" + did + " and certno='" + certno + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "被保人一天内不允许提交2次";
        } else {
          ArrayList<DataPostListBean> oldList = jdbc.db_select("select id,uid,did,read_dt,post_dt,time1,time2,time3,sn,part,policy_number,policy_begin,policy_end,flag,back_cause,back_part,name,certno,keepername,keepercertno,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,c20,c21,c22,c23,c24,c25,c26,c27,c28,c29,c30,c31,c32,c33,c34,c35,c36,c37,c38,c39,c40,error,warning,pz,mylock from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and " + 
              "did in (" + "55,56,57" + ") and certno='" + certno + "'", DataPostListBean.class);
          if (oldList.size() > 0) {
            int old_part = 0;
            for (int x = 0; x < oldList.size(); x++) {
              DataPostListBean postx = oldList.get(x);
              old_part += Tools.getIntExcep(postx.getPart());
            } 
            if (old_part >= 2) {
              error = "被保人已达到投保上限(2份)，无法继续投保";
            } else if (old_part == 1 && part.equals("2")) {
              error = "被保人已投保了1份，无法继续投保2份，请选择1份";
            } 
          } 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(i, name, rowList, 1)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(i));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(dins.getPrice());
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, partx, 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_pa_qnb(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end, String did_scope) {
    String back = "";
    try {
      String did = dins.getId();
      ArrayList<ArrayList> rowList = getRowList(true, json, row, head);
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      int name_min = Tools.getIntExcep(dins.getName_min());
      int name_max = Tools.getIntExcep(dins.getName_max());
      int keeper_min = Tools.getIntExcep(dins.getKeeper_min());
      int keeper_max = Tools.getIntExcep(dins.getKeeper_max());
      int part_all = Tools.getIntExcep(dins.getPart_all());
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      ArrayList allList1 = jdbc.db_select("select part,certno from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and " + did_scope, DataPostList1Bean.class);
      ArrayList allList2 = jdbc.db_select("select part,certno from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and did=" + did + " and post_dt like '" + Tools.getCurrentDate() + "%'", DataPostList1Bean.class);
      for (int i = 0; i < rowList.size(); i++) {
        ArrayList<String> tmp_list = rowList.get(i);
        String error = "", warning = "";
        String ins_name = tmp_list.get(1);
        String email = tmp_list.get(13);
        String guanxi = tmp_list.get(25);
        String name = trim_all(tmp_list.get(14));
        String certno = tmp_list.get(17);
        String keepername = trim_all(tmp_list.get(2));
        String keepercertno = tmp_list.get(5);
        String keepertel = tmp_list.get(7);
        String nameteltype = tmp_list.get(18);
        String keeperteltype = tmp_list.get(6);
        String keepertype = tmp_list.get(3);
        String nametype = tmp_list.get(15);
        String certnotype1 = tmp_list.get(4);
        String certnotype2 = tmp_list.get(16);
        String sex1 = tmp_list.get(21);
        String birthday1 = tmp_list.get(20);
        String sex2 = tmp_list.get(8);
        String birthday2 = tmp_list.get(9);
        if (Tools.isCard(certno)) {
          certno = certno.toLowerCase();
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(20, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(21, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
        } 
        if (Tools.isCard(keepercertno)) {
          keepercertno = keepercertno.toLowerCase();
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(9, tmp_birthday2);
            warning = "投保人生日错误或格式不对";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(8, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人性别错误";
          } 
        } 
        int tmp_age1 = Tools.getAgex(certno);
        int[] el1 = { 
            1, 2, 3, 4, 5, 6, 7, 13, 14, 15, 
            16, 17, 18, 19, 20, 21, 24, 25 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("方案一") && did.equals("73")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("平安全能保10+1（1-6）") && did.equals("114")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("全能保通赔版10+1+50") && did.equals("123")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("全能保通赔版10+2+50") && did.equals("124")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("全能20+2") && did.equals("161")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("四季平安20+2") && (did.equals("195") || did.equals("212"))) {
          error = "投保方案错误";
        } else if (!ins_name.equals("10+1+50") && did.equals("180")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("20+2+100") && did.equals("181")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("30+3+150") && did.equals("182")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("1-6打折10+1") && did.equals("205")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("1-6打折20+2+50") && did.equals("206")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("1-6打折30+3+100") && did.equals("207")) {
          error = "投保方案错误";
        } else if (!keepertype.equals("个人")) {
          error = "投保人类型必须为个人";
        } else if (!nametype.equals("真实被保人")) {
          error = "被保人类型必须为真实被保人";
        } else if (!certnotype1.equals("身份证") || !certnotype2.equals("身份证")) {
          error = "证件类型必须为身份证";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!Tools.CheckStr(keepertel) || !Tools.isTel(keepertel)) {
          error = "投保人联系方式错误";
        } else if (!nameteltype.equals("手机") || !keeperteltype.equals("手机")) {
          error = "联系方式必须是手机";
        } else if (!Tools.isEmail(email)) {
          error = "投保人邮箱错误";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(i, certno, rowList, 17)) {
          error = "被保人证件号重复，被保人限购一份";
        } else if (!isCodeNameRepeat(i, keepername, keepercertno, rowList, 2, 5)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (tmp_age1 >= 18 && (!name.equals(keepername) || !certno.equals(keepercertno))) {
          error = "被保人是成年人，投保人与被保人的姓名、证件号必须一致";
        } else if (tmp_age1 < 18 && (name.equals(keepername) || certno.equals(keepercertno))) {
          error = "被保人是未年人，投保人与被保人的姓名、证件号必须不一致";
        } else if (!Tools.checkAge(keepercertno, keeper_min, keeper_max)) {
          error = "投保人年龄必须 " + keeper_min + "-" + keeper_max + " 周岁";
        } else if (!Tools.checkAge(certno, name_min, name_max)) {
          error = "被保人年龄必须 " + name_min + "-" + name_max + " 周岁";
        } else if (tmp_age1 >= 18 && !guanxi.equals("本人")) {
          error = "被保人是成年人，关系必须为本人";
        } else if (tmp_age1 < 18 && !guanxi.equals("子女")) {
          error = "被保人是未年人，关系必须为子女";
        } else {
          int sum2 = Integer.valueOf(part).intValue();
          for (Object tmp1 : allList1) {
            DataPostList1Bean tmp2 = (DataPostList1Bean)tmp1;
            if (tmp2.getCertno().equals(certno))
              sum2 += Tools.getIntExcep(tmp2.getPart()); 
          } 
          boolean isR = false;
          for (Object tmp1 : allList2) {
            DataPostList1Bean tmp2 = (DataPostList1Bean)tmp1;
            if (tmp2.getCertno().equals(certno)) {
              isR = true;
              break;
            } 
          } 
          if (sum2 > part_all) {
            error = "被保人无法继续投保，(上限为" + part_all + "份)";
          } else if (isR) {
            error = "被保人一天内不允许提交2次";
          } 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(i, name, rowList, 14)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(i));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        bean1.setC12(tmp_list.get(12));
        bean1.setC13(tmp_list.get(13));
        bean1.setC14(tmp_list.get(14));
        bean1.setC15(tmp_list.get(15));
        bean1.setC16(tmp_list.get(16));
        bean1.setC17(tmp_list.get(17));
        bean1.setC18(tmp_list.get(18));
        bean1.setC19(tmp_list.get(19));
        bean1.setC20(tmp_list.get(20));
        bean1.setC21(tmp_list.get(21));
        bean1.setC22(tmp_list.get(22));
        bean1.setC23(tmp_list.get(23));
        bean1.setC24(tmp_list.get(24));
        bean1.setC25(tmp_list.get(25));
        bean1.setC26(tmp_list.get(26));
        bean1.setC27(tmp_list.get(27));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(dins.getPrice());
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_pa_qjf(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      ArrayList allList1 = jdbc.db_select("select part,certno from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and did in (" + "89,90,91,92" + ")", DataPostList1Bean.class);
      ArrayList allList2 = jdbc.db_select("select part,certno from data_post_list where flag<>'4' and did=" + did + " and post_dt like '" + Tools.getCurrentDate() + "%'", DataPostList1Bean.class);
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String ins_name = tmp_list.get(1);
        String email = tmp_list.get(13);
        String guanxi = tmp_list.get(25);
        String name = trim_all(tmp_list.get(14));
        String certno = tmp_list.get(17);
        String keepername = trim_all(tmp_list.get(2));
        String keepercertno = tmp_list.get(5);
        String keepertel = tmp_list.get(7);
        String keepertype = tmp_list.get(3);
        String nametype = tmp_list.get(15);
        String certnotype1 = tmp_list.get(4);
        String certnotype2 = tmp_list.get(16);
        String sex1 = tmp_list.get(21);
        String birthday1 = tmp_list.get(20);
        String sex2 = tmp_list.get(8);
        String birthday2 = tmp_list.get(9);
        if (Tools.isCard(certno)) {
          certno = certno.toLowerCase();
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(20, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(21, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
        } 
        if (Tools.isCard(keepercertno)) {
          keepercertno = keepercertno.toLowerCase();
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(9, tmp_birthday2);
            warning = "投保人生日错误或格式不对";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(8, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人性别错误";
          } 
        } 
        int tmp_age1 = Tools.getAgex(certno);
        int[] el1 = { 
            1, 2, 3, 4, 5, 6, 7, 13, 14, 15, 
            16, 17, 18, 19, 20, 21, 24, 25 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("方案一") && did.equals("89")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案二") && did.equals("90")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案三") && did.equals("91")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案四") && did.equals("92")) {
          error = "投保方案错误";
        } else if (!keepertype.equals("个人")) {
          error = "投保人类型必须为个人";
        } else if (!nametype.equals("真实被保人")) {
          error = "被保人类型必须为真实被保人";
        } else if (!certnotype1.equals("身份证") || !certnotype2.equals("身份证")) {
          error = "证件类型必须为身份证";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!Tools.CheckStr(keepertel) || !Tools.isTel(keepertel)) {
          error = "投保人联系方式错误";
        } else if (!Tools.isEmail(email)) {
          error = "投保人邮箱错误";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 17)) {
          error = "被保人证件号重复，被保人限购一份";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 2, 5)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (tmp_age1 >= 18 && (!name.equals(keepername) || !certno.equals(keepercertno))) {
          error = "被保人是成年人，投保人与被保人的姓名、证件号必须一致";
        } else if (tmp_age1 < 18 && (name.equals(keepername) || certno.equals(keepercertno))) {
          error = "被保人是未年人，投保人与被保人的姓名、证件号必须不一致";
        } else if (!Tools.checkAge(keepercertno, 18, 65)) {
          error = "投保人年龄必须1-65周岁";
        } else if (!Tools.checkAge(certno, 1, 65)) {
          error = "被保人年龄必须 1-65周岁";
        } else if (tmp_age1 >= 18 && !guanxi.equals("本人")) {
          error = "被保人是成年人，关系必须为本人";
        } else if (tmp_age1 < 18 && !guanxi.equals("子女")) {
          error = "被保人是未年人，关系必须为子女";
        } else {
          int sum2 = Integer.valueOf(part).intValue();
          for (Object tmp1 : allList1) {
            DataPostList1Bean tmp2 = (DataPostList1Bean)tmp1;
            if (tmp2.getCertno().equals(certno))
              sum2 += Tools.getIntExcep(tmp2.getPart()); 
          } 
          boolean isR = false;
          for (Object tmp1 : allList2) {
            DataPostList1Bean tmp2 = (DataPostList1Bean)tmp1;
            if (tmp2.getCertno().equals(certno)) {
              isR = true;
              break;
            } 
          } 
          if (sum2 > 1) {
            error = "被保人已投保了1份(上限1份)，无法继续投保";
          } else if (isR) {
            error = "被保人一天内不允许提交2次";
          } 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 14)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        bean1.setC12(tmp_list.get(12));
        bean1.setC13(tmp_list.get(13));
        bean1.setC14(tmp_list.get(14));
        bean1.setC15(tmp_list.get(15));
        bean1.setC16(tmp_list.get(16));
        bean1.setC17(tmp_list.get(17));
        bean1.setC18(tmp_list.get(18));
        bean1.setC19(tmp_list.get(19));
        bean1.setC20(tmp_list.get(20));
        bean1.setC21(tmp_list.get(21));
        bean1.setC22(tmp_list.get(22));
        bean1.setC23(tmp_list.get(23));
        bean1.setC24(tmp_list.get(24));
        bean1.setC25(tmp_list.get(25));
        bean1.setC26(tmp_list.get(26));
        bean1.setC27(tmp_list.get(27));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_pa_14gd(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      int take_size = Tools.getIntExcep(dins.getTake_size());
      String name_min = dins.getName_min();
      String name_max = dins.getName_max();
      String keeper_min = dins.getKeeper_min();
      String keeper_max = dins.getKeeper_max();
      int part_all = Tools.getIntExcep(dins.getPart_all());
      String did_scope = "did=" + did;
      if (Tools.CheckStr(dins.getPart_other_ins()))
        did_scope = "did in (" + dins.getPart_other_ins() + ")"; 
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      ArrayList result_list1 = jdbc.selectList("select certno from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') " + 
          "and did=" + did + " and post_dt like '" + Tools.getCurrentDate() + "%'");
      DataPostListBean beanx = new DataPostListBean();
      beanx.setDid(dins.getId());
      ArrayList result_list2 = jdbc.selectList("select certno," + beanx.getDataPart() + "*part from data_post_list where flag<>'4' and " + 
          "(policy_end is null or Date(policy_end)>'" + policy_end + "') and " + did_scope, 2);
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String ins_name = tmp_list.get(1);
        String email = tmp_list.get(13);
        String guanxi = tmp_list.get(25);
        String name = trim_all(tmp_list.get(14));
        String certno = tmp_list.get(17);
        String keepername = trim_all(tmp_list.get(2));
        String keepercertno = tmp_list.get(5);
        String keepertel = tmp_list.get(7);
        String keepertel2 = tmp_list.get(19);
        String keepertype = tmp_list.get(3);
        String nametype = tmp_list.get(15);
        String certnotype1 = tmp_list.get(4);
        String certnotype2 = tmp_list.get(16);
        String sex1 = tmp_list.get(21);
        String birthday1 = tmp_list.get(20);
        String sex2 = tmp_list.get(8);
        String birthday2 = tmp_list.get(9);
        if (Tools.isCard(certno)) {
          certno = certno.toLowerCase();
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(20, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(21, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
        } 
        if (Tools.isCard(keepercertno)) {
          keepercertno = keepercertno.toLowerCase();
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(9, tmp_birthday2);
            warning = "投保人生日错误或格式不对";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(8, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人性别错误";
          } 
        } 
        int tmp_age1 = Tools.getAgex(certno);
        int[] el1 = { 
            1, 2, 3, 4, 5, 6, 7, 13, 14, 15, 
            16, 17, 18, 19, 20, 21, 25, 26 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("方案一") && did.equals("137")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案二") && did.equals("138")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案三") && did.equals("139")) {
          error = "投保方案错误";
        } else if (!keepertype.equals("个人")) {
          error = "投保人类型必须为个人";
        } else if (!nametype.equals("真实被保人")) {
          error = "被保人类型必须为真实被保人";
        } else if (!certnotype1.equals("身份证") || !certnotype2.equals("身份证")) {
          error = "证件类型必须为身份证";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!Tools.CheckStr(keepertel) || !Tools.isTel(keepertel)) {
          error = "投保人联系方式错误";
        } else if (!Tools.CheckStr(keepertel2) || !Tools.isTel(keepertel2)) {
          error = "被保人联系方式错误";
        } else if (!Tools.isEmail(email)) {
          error = "投保人邮箱错误";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 17)) {
          error = "被保人证件号重复，被保人限购一份";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 2, 5)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (tmp_age1 >= 18 && (!name.equals(keepername) || !certno.equals(keepercertno))) {
          error = "被保人是成年人，投保人与被保人的姓名、证件号必须一致";
        } else if (tmp_age1 < 18 && (name.equals(keepername) || certno.equals(keepercertno))) {
          error = "被保人是未年人，投保人与被保人的姓名、证件号必须不一致";
        } else if (!checkAge(keepercertno, keeper_min, keeper_max)) {
          error = "投保人年龄必须 " + getLimitStr(keeper_min) + "-" + getLimitStr(keeper_max);
        } else if (!checkAge(certno, name_min, name_max)) {
          error = "被保人年龄必须 " + getLimitStr(name_min) + "-" + getLimitStr(name_max);
        } else if (tmp_age1 >= 18 && !guanxi.equals("本人")) {
          error = "被保人是成年人，关系必须为本人";
        } else if (tmp_age1 < 18 && !guanxi.equals("子女")) {
          error = "被保人是未年人，关系必须为子女";
        } else if (isTake(certno, result_list1)) {
          error = "被保人一天内不允许提交2次";
        } else {
          int[] int_arr = getResultSum(certno, result_list2);
          if (take_size > 0 && int_arr[0] >= take_size)
            error = "被保人超出投保次数（" + take_size + "次）"; 
          if (Integer.valueOf(part).intValue() + int_arr[1] > part_all)
            error = "被保人已投保了" + int_arr[1] + "份，超出投保上限（" + part_all + "份）"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 14)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        bean1.setC12(tmp_list.get(12));
        bean1.setC13(tmp_list.get(13));
        bean1.setC14(tmp_list.get(14));
        bean1.setC15(tmp_list.get(15));
        bean1.setC16(tmp_list.get(16));
        bean1.setC17(tmp_list.get(17));
        bean1.setC18(tmp_list.get(18));
        bean1.setC19(tmp_list.get(19));
        bean1.setC20(tmp_list.get(20));
        bean1.setC21(tmp_list.get(21));
        bean1.setC22(tmp_list.get(22));
        bean1.setC23(tmp_list.get(23));
        bean1.setC24(tmp_list.get(24));
        bean1.setC25(tmp_list.get(25));
        bean1.setC26(tmp_list.get(26));
        bean1.setC27(tmp_list.get(27));
        bean1.setC28(tmp_list.get(28));
        bean1.setC29(tmp_list.get(29));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_pa_kjb(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      int take_size = Tools.getIntExcep(dins.getTake_size());
      String name_min = dins.getName_min();
      String name_max = dins.getName_max();
      String keeper_min = dins.getKeeper_min();
      String keeper_max = dins.getKeeper_max();
      int part_all = Tools.getIntExcep(dins.getPart_all());
      String did_scope = "did=" + did;
      if (Tools.CheckStr(dins.getPart_other_ins()))
        did_scope = "did in (" + dins.getPart_other_ins() + ")"; 
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      ArrayList result_list1 = jdbc.selectList("select certno from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') " + 
          "and did=" + did + " and post_dt like '" + Tools.getCurrentDate() + "%'");
      DataPostListBean beanx = new DataPostListBean();
      beanx.setDid(dins.getId());
      ArrayList result_list2 = jdbc.selectList("select certno," + beanx.getDataPart() + "*part from data_post_list where flag<>'4' and " + 
          "(policy_end is null or Date(policy_end)>'" + policy_end + "') and " + did_scope, 2);
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String ins_name = tmp_list.get(1);
        String email = tmp_list.get(13);
        String guanxi = tmp_list.get(25);
        String name = trim_all(tmp_list.get(14));
        String certno = tmp_list.get(17);
        String keepername = trim_all(tmp_list.get(2));
        String keepercertno = tmp_list.get(5);
        String keepertel = tmp_list.get(7);
        String keepertel2 = tmp_list.get(19);
        String teltype1 = tmp_list.get(6);
        String teltype2 = tmp_list.get(18);
        String keepertype = tmp_list.get(3);
        String nametype = tmp_list.get(15);
        String certnotype1 = tmp_list.get(4);
        String certnotype2 = tmp_list.get(16);
        String sex1 = tmp_list.get(21);
        String birthday1 = tmp_list.get(20);
        String jobcode = tmp_list.get(24);
        String sex2 = tmp_list.get(8);
        String birthday2 = tmp_list.get(9);
        if (Tools.isCard(certno)) {
          certno = certno.toLowerCase();
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(20, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(21, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
        } 
        if (Tools.isCard(keepercertno)) {
          keepercertno = keepercertno.toLowerCase();
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(9, tmp_birthday2);
            warning = "投保人生日错误或格式不对";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(8, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人性别错误";
          } 
        } 
        int tmp_age1 = Tools.getAgex(certno);
        int[] el1 = { 
            1, 2, 3, 4, 5, 6, 7, 13, 14, 15, 
            16, 17, 18, 19, 20, 21, 25 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("10+1+50") && (did.equals("68") || did.equals("176") || did.equals("170") || 
          did.equals("128") || did.equals("97") || did.equals("174") || did.equals("159") || 
          did.equals("115") || did.equals("111") || did.equals("140"))) {
          error = "投保方案错误";
        } else if (!ins_name.equals("5+2+50") && (did.equals("69") || did.equals("171") || did.equals("129") || 
          did.equals("116") || did.equals("98") || did.equals("160") || did.equals("112") || 
          did.equals("141"))) {
          error = "投保方案错误";
        } else if (!ins_name.equals("10+2+50") && (did.equals("70") || did.equals("172") || did.equals("130") || 
          did.equals("117") || did.equals("99") || did.equals("113"))) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案一") && did.equals("151")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案二") && did.equals("152")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案三") && did.equals("153")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("20+2+2+50") && did.equals("183")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("30+3+3+50") && did.equals("184")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("40+4+4+50") && did.equals("185")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("猝死版20+1") && did.equals("200")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("猝死版10+1") && did.equals("201")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("猝死版10+1+2") && did.equals("224")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("猝死版30+2+5+60") && did.equals("225")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("互联网版10+1+50") && did.equals("208")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("互联网版5+2+50") && did.equals("209")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("互联网版10+2+50") && did.equals("210")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("四季平安TS版10+1+50") && did.equals("226")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("平安华夏标费版10+1+50") && did.equals("237")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("平安华夏标费版20+2+100") && did.equals("238")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("平安华夏标费版40+4+200") && did.equals("239")) {
          error = "投保方案错误";
        } else if (!keepertype.equals("个人")) {
          error = "投保人类型必须为个人";
        } else if (!nametype.equals("真实被保人")) {
          error = "被保人类型必须为真实被保人";
        } else if (!certnotype1.equals("身份证") || !certnotype2.equals("身份证")) {
          error = "证件类型必须为身份证";
        } else if (!teltype1.equals("手机") || !teltype2.equals("手机")) {
          error = "联系方式类型必须是手机";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!Tools.CheckStr(keepertel) || !Tools.isTel(keepertel)) {
          error = "投保人联系方式错误";
        } else if (!Tools.CheckStr(keepertel2) || !Tools.isTel(keepertel2)) {
          error = "被保人联系方式错误";
        } else if (!Tools.isEmail(email)) {
          error = "投保人邮箱错误";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 17)) {
          error = "被保人证件号重复，被保人限购一份";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 2, 5)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (!Tools.IsInArray("176,200,201,224,225".split(","), dins.getId()) && tmp_age1 >= 18 && (!name.equals(keepername) || !certno.equals(keepercertno))) {
          error = "被保人是成年人，投保人与被保人的姓名、证件号必须一致";
        } else if (tmp_age1 < 18 && (name.equals(keepername) || certno.equals(keepercertno))) {
          error = "被保人是未年人，投保人与被保人的姓名、证件号必须不一致";
        } else if (!checkAge(keepercertno, keeper_min, keeper_max)) {
          error = "投保人年龄必须 " + getLimitStr(keeper_min) + "-" + getLimitStr(keeper_max);
        } else if (!checkAge(certno, name_min, name_max)) {
          error = "被保人年龄必须 " + getLimitStr(name_min) + "-" + getLimitStr(name_max);
        } else if (Tools.IsInArray("208,209,210,224,225,226,237,238,239".split(","), dins.getId()) && !Tools.CheckStr(jobcode)) {
          error = "职业代码不允许为空";
        } else if (!Tools.IsInArray("176,200,201,224,225".split(","), dins.getId()) && tmp_age1 >= 18 && !guanxi.equals("本人")) {
          error = "被保人是成年人，关系必须为本人";
        } else if (tmp_age1 < 18 && !guanxi.equals("子女")) {
          error = "被保人是未年人，关系必须为子女";
        } else if (Tools.IsInArray("176,200,201,224,225".split(","), dins.getId()) && tmp_age1 >= 66 && !guanxi.equals("子女")) {
          error = "需要子女做投保人，关系需为子女";
        } else if (Tools.IsInArray("176,200,201,224,225".split(","), dins.getId()) && tmp_age1 >= 18 && tmp_age1 <= 65 && !guanxi.equals("本人")) {
          error = "被保人是成年人，关系必须为本人";
        } else if (Tools.IsInArray("176,200,201,224,225".split(","), dins.getId()) && tmp_age1 >= 66 && (name.equals(keepername) || certno.equals(keepercertno))) {
          error = "投保人与被保人的姓名、证件号必须不一致";
        } else if (Tools.IsInArray("176,200,201,224,225".split(","), dins.getId()) && tmp_age1 >= 18 && tmp_age1 <= 65 && (!name.equals(keepername) || !certno.equals(keepercertno))) {
          error = "被保人是成年人，投保人与被保人的姓名、证件号必须一致";
        } else if (isTake(certno, result_list1)) {
          error = "被保人一天内不允许提交2次";
        } else {
          int[] int_arr = getResultSum(certno, result_list2);
          if (take_size > 0 && int_arr[0] >= take_size)
            error = "被保人超出投保次数（" + take_size + "次）"; 
          if (Integer.valueOf(part).intValue() + int_arr[1] > part_all)
            error = "被保人已投保了" + int_arr[1] + "份，超出投保上限（" + part_all + "份）"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 14)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        bean1.setC12(tmp_list.get(12));
        bean1.setC13(tmp_list.get(13));
        bean1.setC14(tmp_list.get(14));
        bean1.setC15(tmp_list.get(15));
        bean1.setC16(tmp_list.get(16));
        bean1.setC17(tmp_list.get(17));
        bean1.setC18(tmp_list.get(18));
        bean1.setC19(tmp_list.get(19));
        bean1.setC20(tmp_list.get(20));
        bean1.setC21(tmp_list.get(21));
        bean1.setC22(tmp_list.get(22));
        bean1.setC23(tmp_list.get(23));
        bean1.setC24(tmp_list.get(24));
        bean1.setC25(tmp_list.get(25));
        bean1.setC26(tmp_list.get(26));
        bean1.setC27(tmp_list.get(27));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_pa_olderyy(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      int name_min = Tools.getIntExcep(dins.getName_min());
      int name_max = Tools.getIntExcep(dins.getName_max());
      int keeper_min = Tools.getIntExcep(dins.getKeeper_min());
      int keeper_max = Tools.getIntExcep(dins.getKeeper_max());
      String did_scope = "did=" + did;
      if (Tools.CheckStr(dins.getPart_other_ins()))
        did_scope = "did in (" + dins.getPart_other_ins() + ")"; 
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String ins_name = tmp_list.get(1);
        String email = tmp_list.get(13);
        String guanxi = tmp_list.get(25);
        String name = trim_all(tmp_list.get(14));
        String certno = tmp_list.get(17);
        String keepername = trim_all(tmp_list.get(2));
        String keepercertno = tmp_list.get(5);
        String keepertel = tmp_list.get(7);
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        String sex1 = tmp_list.get(21);
        String birthday1 = tmp_list.get(20);
        String tel = tmp_list.get(19);
        String sex2 = tmp_list.get(8);
        String birthday2 = tmp_list.get(9);
        String type1 = tmp_list.get(3);
        String type2 = tmp_list.get(4);
        String type3 = tmp_list.get(15);
        String type4 = tmp_list.get(16);
        if (Tools.isCard(certno)) {
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(20, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(21, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(9, tmp_birthday2);
            warning = "投保人生日错误或格式不对";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(8, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人性别错误";
          } 
        } 
        int tmp_age1 = Tools.getAgex(certno);
        int[] el1 = { 
            1, 2, 3, 4, 5, 6, 7, 13, 14, 15, 
            16, 17, 18, 19, 20, 21, 24, 25 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("方案一") && (did.equals("71") || did.equals("121") || did.equals("175") || 
          did.equals("147") || did.equals("196"))) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案二") && did.equals("197")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案三") && did.equals("198")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案四") && did.equals("199")) {
          error = "投保方案错误";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!type1.equals("个人")) {
          error = "投保人类型必须为个人";
        } else if (!type2.equals("身份证") || !type4.equals("身份证")) {
          error = "证件类型必须为身份证";
        } else if (!type3.equals("真实被保人")) {
          error = "被保险人属性必须为真实被保人";
        } else if (!Tools.CheckStr(keepertel) || !Tools.isTel(keepertel)) {
          error = "投保人联系方式错误";
        } else if (!Tools.CheckStr(tel) || !Tools.isTel(tel)) {
          error = "被保人联系方式错误";
        } else if (!Tools.isEmail(email)) {
          error = "投保人邮箱错误";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 17)) {
          error = "被保人证件号重复，被保人限购一份";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 2, 5)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (!name.equals(keepername) || !certno.equals(keepercertno)) {
          error = "被保人是成年人，投保人与被保人的姓名、证件号必须一致";
        } else if (!Tools.checkAge(keepercertno, keeper_min, keeper_max)) {
          error = "被保人年龄必须 " + keeper_min + "-" + keeper_max + "周岁";
        } else if (!Tools.checkAge(certno, name_min, name_max)) {
          error = "被保人年龄必须 " + name_min + "-" + name_max + "周岁";
        } else if (!guanxi.equals("本人")) {
          error = "被保人是成年人，关系必须为本人";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') " + 
            "and " + did_scope + " and certno='" + certno + "'")) {
          error = "被保人已达到投保上限(1份)，无法继续投保";
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 14)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        bean1.setC12(tmp_list.get(12));
        bean1.setC13(tmp_list.get(13));
        bean1.setC14(tmp_list.get(14));
        bean1.setC15(tmp_list.get(15));
        bean1.setC16(tmp_list.get(16));
        bean1.setC17(tmp_list.get(17));
        bean1.setC18(tmp_list.get(18));
        bean1.setC19(tmp_list.get(19));
        bean1.setC20(tmp_list.get(20));
        bean1.setC21(tmp_list.get(21));
        bean1.setC22(tmp_list.get(22));
        bean1.setC23(tmp_list.get(23));
        bean1.setC24(tmp_list.get(24));
        bean1.setC25(tmp_list.get(25));
        bean1.setC26(tmp_list.get(26));
        bean1.setC27(tmp_list.get(27));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_pa_lx10150_cr(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String ins_name = tmp_list.get(1);
        String email = tmp_list.get(13);
        String guanxi = tmp_list.get(27);
        String name = trim_all(tmp_list.get(14));
        String certno = tmp_list.get(17);
        String keepername = trim_all(tmp_list.get(2));
        String keepercertno = tmp_list.get(5);
        String keepertel = tmp_list.get(7);
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        String keepertype = tmp_list.get(3);
        String nametype = tmp_list.get(15);
        String certnotype1 = tmp_list.get(4);
        String certnotype2 = tmp_list.get(16);
        String sex1 = tmp_list.get(21);
        String birthday1 = tmp_list.get(20);
        String sex2 = tmp_list.get(8);
        String birthday2 = tmp_list.get(9);
        if (Tools.isCard(certno)) {
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(20, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(21, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(9, tmp_birthday2);
            warning = "投保人生日错误或格式不对";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(8, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人性别错误";
          } 
        } 
        int tmp_age1 = Tools.getAgex(certno);
        int[] el1 = { 
            1, 2, 3, 4, 5, 6, 7, 13, 14, 15, 
            16, 17, 18, 19, 20, 21, 27 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("方案一") && did.equals("74")) {
          error = "投保方案错误";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!Tools.CheckStr(keepertel) || !Tools.isTel(keepertel)) {
          error = "投保人联系方式错误";
        } else if (!Tools.isEmail(email)) {
          error = "投保人邮箱错误";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (!keepertype.equals("个人")) {
          error = "投保人类型必须为个人";
        } else if (!nametype.equals("真实被保人")) {
          error = "被保人类型必须为真实被保人";
        } else if (!certnotype1.equals("身份证") || !certnotype2.equals("身份证")) {
          error = "证件类型必须为身份证";
        } else if (isValueRepeat(j, certno, rowList, 17)) {
          error = "被保人证件号重复，被保人限购一份";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 2, 5)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (tmp_age1 >= 18 && (!name.equals(keepername) || !certno.equals(keepercertno))) {
          error = "被保人是成年人，投保人与被保人的姓名、证件号必须一致";
        } else if (tmp_age1 < 18 && (name.equals(keepername) || certno.equals(keepercertno))) {
          error = "被保人是未年人，投保人与被保人的姓名、证件号必须不一致";
        } else if (!Tools.checkAge(certno, 18, 65)) {
          error = "被保人年龄必须 18-65周岁";
        } else if (tmp_age1 >= 18 && !guanxi.equals("本人")) {
          error = "关系必须为本人";
        } else if (tmp_age1 < 18 && !guanxi.equals("子女")) {
          error = "被保人是未年人，关系必须为子女";
        } else {
          int sum2 = Tools.getIntExcep(jdbc.selectOnlyField("select sum(part) from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + 
                policy_end + "') and did in (" + "74" + ") and certno='" + certno + "'"));
          sum2 += Integer.valueOf(part).intValue();
          if (sum2 > 2) {
            error = "被保人已投保了2份(上限2份)，无法继续投保";
          } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did=" + did + " and certno='" + certno + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
            error = "被保人一天内不允许提交2次";
          } 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 14)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        bean1.setC12(tmp_list.get(12));
        bean1.setC13(tmp_list.get(13));
        bean1.setC14(tmp_list.get(14));
        bean1.setC15(tmp_list.get(15));
        bean1.setC16(tmp_list.get(16));
        bean1.setC17(tmp_list.get(17));
        bean1.setC18(tmp_list.get(18));
        bean1.setC19(tmp_list.get(19));
        bean1.setC20(tmp_list.get(20));
        bean1.setC21(tmp_list.get(21));
        bean1.setC22(tmp_list.get(22));
        bean1.setC23(tmp_list.get(23));
        bean1.setC24(tmp_list.get(24));
        bean1.setC25(tmp_list.get(25));
        bean1.setC26(tmp_list.get(26));
        bean1.setC27(tmp_list.get(27));
        bean1.setC28(tmp_list.get(28));
        bean1.setC29(tmp_list.get(29));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_pa_lx10150(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String ins_name = tmp_list.get(1);
        String email = tmp_list.get(13);
        String guanxi = tmp_list.get(27);
        String name = trim_all(tmp_list.get(14));
        String certno = tmp_list.get(17);
        String keepername = trim_all(tmp_list.get(2));
        String keepercertno = tmp_list.get(5);
        String keepertel = tmp_list.get(7);
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        String keepertype = tmp_list.get(3);
        String nametype = tmp_list.get(15);
        String certnotype1 = tmp_list.get(4);
        String certnotype2 = tmp_list.get(16);
        String sex1 = tmp_list.get(21);
        String birthday1 = tmp_list.get(20);
        String sex2 = tmp_list.get(8);
        String birthday2 = tmp_list.get(9);
        if (Tools.isCard(certno)) {
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(20, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(21, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(9, tmp_birthday2);
            warning = "投保人生日错误或格式不对";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(8, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人性别错误";
          } 
        } 
        int tmp_age1 = Tools.getAgex(certno);
        int[] el1 = { 
            1, 2, 3, 4, 5, 6, 7, 13, 14, 15, 
            16, 17, 18, 19, 20, 21, 27, 28 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("方案一") && did.equals("72")) {
          error = "投保方案错误";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!Tools.CheckStr(keepertel) || !Tools.isTel(keepertel)) {
          error = "投保人联系方式错误";
        } else if (!Tools.isEmail(email)) {
          error = "投保人邮箱错误";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (!keepertype.equals("个人")) {
          error = "投保人类型必须为个人";
        } else if (!nametype.equals("真实被保人")) {
          error = "被保人类型必须为真实被保人";
        } else if (!certnotype1.equals("身份证") || !certnotype2.equals("身份证")) {
          error = "证件类型必须为身份证";
        } else if (isValueRepeat(j, certno, rowList, 17)) {
          error = "被保人证件号重复，被保人限购一份";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 2, 5)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (tmp_age1 >= 18 && (!name.equals(keepername) || !certno.equals(keepercertno))) {
          error = "被保人是成年人，投保人与被保人的姓名、证件号必须一致";
        } else if (tmp_age1 < 18 && (name.equals(keepername) || certno.equals(keepercertno))) {
          error = "被保人是未年人，投保人与被保人的姓名、证件号必须不一致";
        } else if (!Tools.checkAge(certno, 1, 65)) {
          error = "被保人年龄必须 1-65周岁";
        } else if (tmp_age1 >= 18 && !guanxi.equals("本人")) {
          error = "关系必须为本人";
        } else if (tmp_age1 < 18 && !guanxi.equals("子女")) {
          error = "被保人是未年人，关系必须为子女";
        } else {
          int sum2 = Tools.getIntExcep(jdbc.selectOnlyField("select sum(part) from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + 
                policy_end + "') and did in (" + "72" + ") and certno='" + certno + "'"));
          sum2 += Integer.valueOf(part).intValue();
          if (sum2 > 2) {
            error = "被保人已投保了2份(上限2份)，无法继续投保";
          } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did=" + did + " and certno='" + certno + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
            error = "被保人一天内不允许提交2次";
          } 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 14)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        bean1.setC12(tmp_list.get(12));
        bean1.setC13(tmp_list.get(13));
        bean1.setC14(tmp_list.get(14));
        bean1.setC15(tmp_list.get(15));
        bean1.setC16(tmp_list.get(16));
        bean1.setC17(tmp_list.get(17));
        bean1.setC18(tmp_list.get(18));
        bean1.setC19(tmp_list.get(19));
        bean1.setC20(tmp_list.get(20));
        bean1.setC21(tmp_list.get(21));
        bean1.setC22(tmp_list.get(22));
        bean1.setC23(tmp_list.get(23));
        bean1.setC24(tmp_list.get(24));
        bean1.setC25(tmp_list.get(25));
        bean1.setC26(tmp_list.get(26));
        bean1.setC27(tmp_list.get(27));
        bean1.setC28(tmp_list.get(28));
        bean1.setC29(tmp_list.get(29));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_ts(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end, String did_scope) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      String name_min = dins.getName_min();
      String name_max = dins.getName_max();
      String keeper_min = dins.getKeeper_min();
      String keeper_max = dins.getKeeper_max();
      int part_all = Tools.getIntExcep(dins.getPart_all());
      ArrayList result_list1 = jdbc.selectList("select certno from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') " + 
          "and did=" + did + " and post_dt like '" + Tools.getCurrentDate() + "%'");
      DataPostListBean beanx = new DataPostListBean();
      beanx.setDid(dins.getId());
      ArrayList result_list2 = jdbc.selectList("select certno," + beanx.getDataPart() + "*part from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and " + did_scope, 2);
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String ins_name = tmp_list.get(1);
        String email = tmp_list.get(10);
        String guanxi = tmp_list.get(18);
        String name = trim_all(tmp_list.get(11));
        String certno = tmp_list.get(14);
        String keepername = trim_all(tmp_list.get(2));
        String keepercertno = tmp_list.get(5);
        String keepertel = tmp_list.get(7);
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        String birthday1 = tmp_list.get(15);
        String sex1 = tmp_list.get(16);
        String sex2 = tmp_list.get(8);
        String birthday2 = tmp_list.get(9);
        String type1 = tmp_list.get(3);
        String type2 = tmp_list.get(4);
        String type3 = tmp_list.get(6);
        String type4 = tmp_list.get(12);
        String type5 = tmp_list.get(13);
        if (Tools.isCard(certno)) {
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(15, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(16, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(9, tmp_birthday2);
            warning = "投保人生日错误或格式不对";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(8, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人性别错误";
          } 
        } 
        int tmp_age1 = Tools.getAgex(certno);
        int[] el1 = { 
            1, 2, 3, 4, 5, 6, 7, 10, 11, 12, 
            13, 14, 15, 16, 17, 18 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("方案一") && did.equals("165")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案二") && did.equals("166")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案三") && did.equals("167")) {
          error = "投保方案错误";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!type1.equals("个人")) {
          error = "投保人类型必须为个人";
        } else if (!type2.equals("身份证") || !type5.equals("身份证")) {
          error = "证件类型必须为身份证";
        } else if (!type3.equals("手机")) {
          error = "投保人联系方式类型必须为手机";
        } else if (!type4.equals("真实被保人")) {
          error = "被保险人属性必须为真实被保人";
        } else if (!Tools.CheckStr(keepertel) || !Tools.isTel(keepertel)) {
          error = "投保人联系方式错误";
        } else if (!Tools.isEmail(email)) {
          error = "投保人邮箱错误";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 14)) {
          error = "被保人证件号重复，被保人限购一份";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 2, 5)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (tmp_age1 >= 18 && (!name.equals(keepername) || !certno.equals(keepercertno))) {
          error = "被保人是成年人，投保人与被保人的姓名、证件号必须一致";
        } else if (tmp_age1 < 18 && (name.equals(keepername) || certno.equals(keepercertno))) {
          error = "被保人是未年人，投保人与被保人的姓名、证件号必须不一致";
        } else if (!checkAge(keepercertno, keeper_min, keeper_max)) {
          error = "投保人年龄必须 " + getLimitStr(keeper_min) + "-" + getLimitStr(keeper_max);
        } else if (!checkAge(certno, name_min, name_max)) {
          error = "被保人年龄必须 " + getLimitStr(name_min) + "-" + getLimitStr(name_max);
        } else if (tmp_age1 >= 18 && !guanxi.equals("本人")) {
          error = "被保人是成年人，关系必须为本人";
        } else if (tmp_age1 < 18 && !guanxi.equals("子女")) {
          error = "被保人是未年人，关系必须为子女";
        } else if (isTake(certno, result_list1)) {
          error = "被保人一天内不允许提交2次";
        } else {
          int[] int_arr = getResultSum(certno, result_list2);
          if (1 + int_arr[1] > part_all)
            error = "被保人已投保了" + int_arr[1] + "份，超出投保上限（" + part_all + "份）"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 14)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        bean1.setC12(tmp_list.get(12));
        bean1.setC13(tmp_list.get(13));
        bean1.setC14(tmp_list.get(14));
        bean1.setC15(tmp_list.get(15));
        bean1.setC16(tmp_list.get(16));
        bean1.setC17(tmp_list.get(17));
        bean1.setC18(tmp_list.get(18));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_sijipingan_yx(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      String name_min = dins.getName_min();
      String name_max = dins.getName_max();
      String keeper_min = dins.getKeeper_min();
      String keeper_max = dins.getKeeper_max();
      int part_all = Tools.getIntExcep(dins.getPart_all());
      String did_scope = "did=" + did;
      if (Tools.CheckStr(dins.getPart_other_ins()))
        did_scope = "did in (" + dins.getPart_other_ins() + ")"; 
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String ins_name = tmp_list.get(1);
        String email = tmp_list.get(13);
        String guanxi = tmp_list.get(25);
        String name = trim_all(tmp_list.get(14));
        String certno = tmp_list.get(17);
        String teltype = tmp_list.get(18);
        String keepername = trim_all(tmp_list.get(2));
        String keepercertno = tmp_list.get(5);
        String keeperteltype = tmp_list.get(6);
        String keepertel = tmp_list.get(7);
        String tel = tmp_list.get(19);
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        String sex1 = tmp_list.get(21);
        String birthday1 = tmp_list.get(20);
        String sex2 = tmp_list.get(8);
        String birthday2 = tmp_list.get(9);
        String job = tmp_list.get(24);
        String type1 = tmp_list.get(3);
        String type2 = tmp_list.get(4);
        String type3 = tmp_list.get(15);
        String type4 = tmp_list.get(16);
        if (Tools.isCard(certno)) {
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(20, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(21, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(9, tmp_birthday2);
            warning = "投保人生日错误或格式不对";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(8, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人性别错误";
          } 
        } 
        int tmp_age1 = Tools.getAgex(certno);
        int[] el1 = { 
            1, 2, 3, 4, 5, 6, 7, 13, 14, 15, 
            16, 17, 18, 19, 20, 21, 25 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!ins_name.equals("方案一") && Tools.IsInArray("45,104".split(","), did)) {
          error = "投保方案错误";
        } else if (!ins_name.equals("方案二") && Tools.IsInArray("46,105".split(","), did)) {
          error = "投保方案错误";
        } else if (!ins_name.equals("全民保10+1") && did.equals("106")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("全民保10+1") && did.equals("173")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("全民保40+2") && did.equals("146")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("全民10+0.5") && did.equals("157")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("全民20+1") && did.equals("158")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("10+1+50") && did.equals("186")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("平安1-3类CQ版10+1") && did.equals("203")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("平安1-3类CQ版30+3") && did.equals("204")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("平安标费意外猝死版10+1+50+5") && did.equals("213")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("平安标费意外猝死版20+2+80+5") && did.equals("214")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("平安标费意外猝死版30+3+80+5") && did.equals("215")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("平安标费意外猝死版40+4+80+5") && did.equals("216")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("平安标费意外猝死版50+5+80+5") && did.equals("217")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("平安意外低赔版10+1+50") && did.equals("230")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("四季平安飞火轮版10+1") && did.equals("235")) {
          error = "投保方案错误";
        } else if (!ins_name.equals("四季平安飞火轮版10+2") && did.equals("236")) {
          error = "投保方案错误";
        } else if (!Tools.CheckStr(job) && Tools.IsInArray("186,203,204,213,214,215,216,217,230,235,236".split(","), did)) {
          error = "职业代码不可为空";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (!type1.equals("个人")) {
          error = "投保人类型必须为个人";
        } else if (!type2.equals("身份证") || !type4.equals("身份证")) {
          error = "证件类型必须为身份证";
        } else if (!type3.equals("真实被保人")) {
          error = "被保险人属性必须为真实被保人";
        } else if (!Tools.CheckStr(keepertel) || !Tools.isTel(keepertel)) {
          error = "投保人联系方式错误";
        } else if (!keeperteltype.equals("手机") || !teltype.equals("手机")) {
          error = "联系方式必须是手机";
        } else if (!Tools.CheckStr(tel) || !Tools.isTel(tel)) {
          error = "被保人联系方式错误";
        } else if (!Tools.isEmail(email)) {
          error = "投保人邮箱错误";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (isValueRepeat(j, certno, rowList, 17)) {
          error = "被保人证件号重复，被保人限购一份";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 2, 5)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (tmp_age1 >= 18 && (!name.equals(keepername) || !certno.equals(keepercertno)) && !Tools.IsInArray("235,236".split(","), did)) {
          error = "被保人是成年人，投保人与被保人的姓名、证件号必须一致";
        } else if (tmp_age1 < 18 && (name.equals(keepername) || certno.equals(keepercertno)) && !Tools.IsInArray("235,236".split(","), did)) {
          error = "被保人是未年人，投保人与被保人的姓名、证件号必须不一致";
        } else if (!checkAge(keepercertno, keeper_min, keeper_max)) {
          error = "投保人年龄必须 " + getLimitStr(keeper_min) + "-" + getLimitStr(keeper_max);
        } else if (!checkAge(certno, name_min, name_max)) {
          error = "被保人年龄必须 " + getLimitStr(name_min) + "-" + getLimitStr(name_max);
        } else if (tmp_age1 >= 18 && !guanxi.equals("本人") && !Tools.IsInArray("235,236".split(","), did)) {
          error = "被保人是成年人，关系必须为本人";
        } else if (tmp_age1 < 18 && !guanxi.equals("子女") && !Tools.IsInArray("235,236".split(","), did)) {
          error = "被保人是未年人，关系必须为子女";
        } else if (tmp_age1 >= 60 && !guanxi.equals("子女") && Tools.IsInArray("235,236".split(","), did)) {
          error = "关系必须为子女";
        } else if (tmp_age1 <= 59 && !guanxi.equals("本人") && Tools.IsInArray("235,236".split(","), did)) {
          error = "关系必须为本人";
        } else {
          int sum2 = Tools.getIntExcep(jdbc.selectOnlyField("select sum(part) from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and " + did_scope + " and certno='" + certno + "'"));
          sum2 += Integer.valueOf(part).intValue();
          if (sum2 > part_all) {
            error = "被保人已投保了" + part_all + "份(上限" + part_all + "份)，无法继续投保";
          } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did=" + did + " and certno='" + certno + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
            error = "被保人一天内不允许提交2次";
          } 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 14)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        bean1.setC12(tmp_list.get(12));
        bean1.setC13(tmp_list.get(13));
        bean1.setC14(tmp_list.get(14));
        bean1.setC15(tmp_list.get(15));
        bean1.setC16(tmp_list.get(16));
        bean1.setC17(tmp_list.get(17));
        bean1.setC18(tmp_list.get(18));
        bean1.setC19(tmp_list.get(19));
        bean1.setC20(tmp_list.get(20));
        bean1.setC21(tmp_list.get(21));
        bean1.setC22(tmp_list.get(22));
        bean1.setC23(tmp_list.get(23));
        bean1.setC24(tmp_list.get(24));
        bean1.setC25(tmp_list.get(25));
        bean1.setC26(tmp_list.get(26));
        bean1.setC27(tmp_list.get(27));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, String.valueOf(partx), 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_pa_hx(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end, String did_scope) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      int name_min = Tools.getIntExcep(dins.getName_min());
      int name_max = Tools.getIntExcep(dins.getName_max());
      int keeper_min = Tools.getIntExcep(dins.getKeeper_min());
      int keeper_max = Tools.getIntExcep(dins.getKeeper_max());
      int take_size = Tools.getIntExcep(dins.getTake_size());
      int part_all = Tools.getIntExcep(dins.getPart_all());
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      ArrayList result_list1 = jdbc.selectList("select certno from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') " + 
          "and did=" + did + " and post_dt like '" + Tools.getCurrentDate() + "%'");
      DataPostListBean beanx = new DataPostListBean();
      beanx.setDid(dins.getId());
      ArrayList result_list2 = jdbc.selectList("select certno," + beanx.getDataPart() + "*part from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and " + did_scope, 2);
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String name = trim_all(tmp_list.get(8));
        String certno = tmp_list.get(11);
        String keepername = trim_all(tmp_list.get(1));
        String keepercertno = tmp_list.get(4);
        String sex1 = tmp_list.get(9);
        String birthday1 = tmp_list.get(12);
        String sex2 = tmp_list.get(2);
        String birthday2 = tmp_list.get(5);
        String certnotype1 = tmp_list.get(3);
        String certnotype2 = tmp_list.get(10);
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        int tmp_age1 = 0;
        if (Tools.isCard(certno)) {
          tmp_age1 = Tools.getAgex(certno);
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(12, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(9, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(5, tmp_birthday2);
            warning = "投保人生日错误或格式不对";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(2, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人生日性别";
          } 
        } 
        int[] el1 = { 
            1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 
            11, 12, 13, 14, 15 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (!Tools.checkAge(keepercertno, keeper_min, keeper_max)) {
          error = "投保人年龄必须 " + keeper_min + "-" + keeper_max + " 周岁";
        } else if (!Tools.checkAge(certno, name_min, name_max)) {
          error = "被保人年龄必须 " + name_min + "-" + name_max + " 周岁";
        } else if (!certnotype1.equals("身份证") || !certnotype2.equals("身份证")) {
          error = "证件类型必须是身份证";
        } else if (tmp_age1 < 18 && (name.equals(keepername) || certno.equals(keepercertno))) {
          error = "被保人是未成年人，投保人与被保人的姓名、证件号必须不一致";
        } else if (tmp_age1 >= 18 && (!name.equals(keepername) || !certno.equals(keepercertno))) {
          error = "被保人是成年人，投保人与被保人的姓名、证件号必须一致";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 1, 4)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (isValueRepeat(j, certno, rowList, 11)) {
          error = "被保人在一份数据中不允许重复";
        } else if (isTake(certno, result_list1)) {
          error = "被保人一天内不允许提交2次";
        } else {
          int[] int_arr = getResultSum(certno, result_list2);
          if (take_size > 0 && int_arr[0] >= take_size)
            error = "被保人超出投保次数（" + take_size + "次）"; 
          if (Tools.getIntExcep(part) + int_arr[1] > part_all)
            error = "被保人已投保了" + int_arr[1] + "份，超出投保上限（" + part_all + "份）"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 8)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        bean1.setC12(tmp_list.get(12));
        bean1.setC13(tmp_list.get(13));
        bean1.setC14(tmp_list.get(14));
        bean1.setC15(tmp_list.get(15));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, partx, 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_pa_olderyybnxB(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      int name_min = Tools.getIntExcep(dins.getName_min());
      int name_max = Tools.getIntExcep(dins.getName_max());
      int keeper_min = Tools.getIntExcep(dins.getKeeper_min());
      int keeper_max = Tools.getIntExcep(dins.getKeeper_max());
      int take_size = Tools.getIntExcep(dins.getTake_size());
      int part_all = Tools.getIntExcep(dins.getPart_all());
      String did_scope = "did=" + did;
      if (Tools.CheckStr(dins.getPart_other_ins()))
        did_scope = "did in (" + dins.getPart_other_ins() + ")"; 
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      ArrayList result_list1 = jdbc.selectList("select certno from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') " + 
          "and did=" + did + " and post_dt like '" + Tools.getCurrentDate() + "%'");
      DataPostListBean beanx = new DataPostListBean();
      beanx.setDid(dins.getId());
      ArrayList result_list2 = jdbc.selectList("select certno," + beanx.getDataPart() + "*part from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and " + did_scope, 2);
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String name = trim_all(tmp_list.get(7));
        String certno = tmp_list.get(10);
        String keepername = trim_all(tmp_list.get(1));
        String keepercertno = tmp_list.get(4);
        String sex1 = tmp_list.get(8);
        String birthday1 = tmp_list.get(11);
        String sex2 = tmp_list.get(2);
        String birthday2 = tmp_list.get(5);
        String certnotype1 = tmp_list.get(3);
        String certnotype2 = tmp_list.get(9);
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        int tmp_age1 = 0;
        if (Tools.isCard(certno)) {
          tmp_age1 = Tools.getAgex(certno);
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(11, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(8, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(5, tmp_birthday2);
            warning = "投保人生日错误或格式不对";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(2, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人生日性别";
          } 
        } 
        int[] el1 = { 
            1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 
            11 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (!Tools.checkAge(keepercertno, keeper_min, keeper_max)) {
          error = "投保人年龄必须 " + keeper_min + "-" + keeper_max + " 周岁";
        } else if (!Tools.checkAge(certno, name_min, name_max)) {
          error = "被保人年龄必须 " + name_min + "-" + name_max + " 周岁";
        } else if (!certnotype1.equals("身份证") || !certnotype2.equals("身份证")) {
          error = "证件类型必须是身份证";
        } else if (tmp_age1 < 18 && (name.equals(keepername) || certno.equals(keepercertno))) {
          error = "被保人是未成年人，投保人与被保人的姓名、证件号必须不一致";
        } else if (tmp_age1 >= 18 && (!name.equals(keepername) || !certno.equals(keepercertno))) {
          error = "被保人是成年人，投保人与被保人的姓名、证件号必须一致";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 1, 4)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (isValueRepeat(j, certno, rowList, 10)) {
          error = "被保人在一份数据中不允许重复";
        } else if (isTake(certno, result_list1)) {
          error = "被保人一天内不允许提交2次";
        } else {
          int[] int_arr = getResultSum(certno, result_list2);
          if (take_size > 0 && int_arr[0] >= take_size)
            error = "被保人超出投保次数（" + take_size + "次）"; 
          if (1 + int_arr[1] > part_all)
            error = "被保人已投保了" + int_arr[1] + "份，超出投保上限（" + part_all + "份）"; 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 7)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, partx, 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_did_pa_g(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      int name_min = Tools.getIntExcep(dins.getName_min());
      int name_max = Tools.getIntExcep(dins.getName_max());
      int keeper_min = Tools.getIntExcep(dins.getKeeper_min());
      int keeper_max = Tools.getIntExcep(dins.getKeeper_max());
      int take_size = Tools.getIntExcep(dins.getTake_size());
      String did_scope = "did=" + did;
      if (Tools.CheckStr(dins.getPart_other_ins()))
        did_scope = "did in (" + dins.getPart_other_ins() + ")"; 
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String name = trim_all(tmp_list.get(7));
        String certno = tmp_list.get(10);
        String keepername = trim_all(tmp_list.get(1));
        String keepercertno = tmp_list.get(4);
        String sex1 = tmp_list.get(8);
        String birthday1 = tmp_list.get(11);
        String sex2 = tmp_list.get(2);
        String birthday2 = tmp_list.get(5);
        String certnotype1 = tmp_list.get(3);
        String certnotype2 = tmp_list.get(9);
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        int tmp_age1 = 0;
        if (Tools.isCard(certno)) {
          tmp_age1 = Tools.getAgex(certno);
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(11, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(8, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(5, tmp_birthday2);
            warning = "投保人生日错误或格式不对";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(2, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人生日性别";
          } 
        } 
        int[] el1 = { 
            1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 
            11 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (!Tools.checkAge(keepercertno, keeper_min, keeper_max)) {
          error = "投保人年龄必须 " + keeper_min + "-" + keeper_max + " 周岁";
        } else if (!Tools.checkAge(certno, name_min, name_max)) {
          error = "被保人年龄必须 " + name_min + "-" + name_max + " 周岁";
        } else if (!certnotype1.equals("身份证") || !certnotype2.equals("身份证")) {
          error = "证件类型必须是身份证";
        } else if (tmp_age1 < 18 && (name.equals(keepername) || certno.equals(keepercertno))) {
          error = "被保人是未成年人，投保人与被保人的姓名、证件号必须不一致";
        } else if (tmp_age1 >= 18 && (!name.equals(keepername) || !certno.equals(keepercertno))) {
          error = "被保人是成年人，投保人与被保人的姓名、证件号必须一致";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 1, 4)) {
          error = "投保人证件号一致，姓名不一致";
        } else if (isValueRepeat(j, certno, rowList, 10)) {
          error = "被保人在一份数据中不允许重复";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did=" + did + " and certno='" + certno + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "被保人一天内不允许提交2次";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did in (6,7,10) and certno='" + certno + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "不能同时投保四季平安成年未成年";
        } else {
          ArrayList<DataPostListBean> oldList = jdbc.db_select("select id,uid,did,read_dt,post_dt,time1,time2,time3,sn,part,policy_number,policy_begin,policy_end,flag,back_cause,back_part,name,certno,keepername,keepercertno,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,c20,c21,c22,c23,c24,c25,c26,c27,c28,c29,c30,c31,c32,c33,c34,c35,c36,c37,c38,c39,c40,error,warning,pz,mylock from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and " + did_scope + " and certno='" + certno + "'", DataPostListBean.class);
          if (oldList.size() > 0) {
            int old_part = 0;
            for (int x = 0; x < oldList.size(); x++) {
              DataPostListBean postx = oldList.get(x);
              old_part += Tools.getIntExcep(postx.getPart());
            } 
            if (old_part >= 2) {
              error = "被保人已达到投保上限(2份)，无法继续投保";
            } else if (old_part == 1 && part.equals("2")) {
              error = "被保人已投保了1份，无法继续投保2份，请选择1份";
            } 
          } 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 7)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, partx, 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_sijipingan(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String name = trim_all(tmp_list.get(1));
        String certno = tmp_list.get(4);
        String keepername = trim_all(tmp_list.get(6));
        String keepercertno = tmp_list.get(9);
        String sex1 = tmp_list.get(2);
        String birthday1 = tmp_list.get(5);
        String sex2 = tmp_list.get(7);
        String birthday2 = tmp_list.get(10);
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        if (Tools.isCard(certno)) {
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(5, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(2, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误";
          } 
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(10, tmp_birthday2);
            warning = "投保人生日错误或格式不对";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(7, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人生日性别";
          } 
        } 
        int[] el1 = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (!Tools.checkAge(keepercertno, 18, 65)) {
          error = "投保人年龄必须 18-65周岁";
        } else if (!Tools.checkAge(certno, 18, 65)) {
          error = "被保人年龄必须 18-65周岁";
        } else if (!name.equals(keepername) || !certno.equals(keepercertno)) {
          error = "前后的姓名，证件号必须一致";
        } else if (isValueRepeat(j, certno, rowList, 4)) {
          error = "被保人在一份数据中不允许重复";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did=" + did + " and c4='" + certno + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "被保人一天内不允许提交2次";
        } else {
          ArrayList<DataPostListBean> oldList = jdbc.db_select("select id,uid,did,read_dt,post_dt,time1,time2,time3,sn,part,policy_number,policy_begin,policy_end,flag,back_cause,back_part,name,certno,keepername,keepercertno,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,c20,c21,c22,c23,c24,c25,c26,c27,c28,c29,c30,c31,c32,c33,c34,c35,c36,c37,c38,c39,c40,error,warning,pz,mylock from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and did in (" + "6,7,10,36,37,38" + ") and c4='" + certno + "'", DataPostListBean.class);
          if (oldList.size() > 0) {
            int old_part = 0;
            for (int x = 0; x < oldList.size(); x++) {
              DataPostListBean postx = oldList.get(x);
              old_part += Tools.getIntExcep(postx.getPart());
            } 
            if (old_part >= 2) {
              error = "被保人已达到投保上限(2份)，无法继续投保";
            } else if (old_part == 1 && part.equals("2")) {
              error = "被保人已投保了1份，无法继续投保2份，请选择1份";
            } 
          } 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 1)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, partx, 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  public String readExcel_sijipingan_ertong(String json, String part, DataInsBean dins, int row, String[] head, HttpSession session, String policy_end) {
    String back = "";
    try {
      String did = dins.getId();
      String ins_price = dins.getPrice();
      ArrayList<ArrayList<Integer>> rowList = new ArrayList();
      JSONArray jsonList = new JSONArray(json);
      for (int i = 0; i < jsonList.length(); i++) {
        JSONObject tmp1 = jsonList.getJSONObject(i);
        ArrayList<Integer> tmp_row = new ArrayList();
        tmp_row.add(Integer.valueOf(i));
        for (int k = 0; k < head.length; k++)
          tmp_row.add(tmp1.get(String.valueOf(head[k]) + row)); 
        rowList.add(tmp_row);
        row++;
      } 
      Jdbc jdbc = new Jdbc();
      String sn = Tools.getId();
      String post_dt = Tools.getCurrentDateTime();
      String price = this.mb.getPriceNew(did, jdbc);
      String partx = Tools.getProduct(part, String.valueOf(rowList.size()), 0);
      ArrayList<DataPostListBean> post_list = new ArrayList();
      for (int j = 0; j < rowList.size(); j++) {
        ArrayList<String> tmp_list = (ArrayList)rowList.get(j);
        String error = "", warning = "";
        String name = trim_all(tmp_list.get(1));
        String certno = tmp_list.get(4);
        String keepername = trim_all(tmp_list.get(6));
        String keepercertno = tmp_list.get(9);
        String sex1 = tmp_list.get(2);
        String birthday1 = tmp_list.get(5);
        String sex2 = tmp_list.get(7);
        String birthday2 = tmp_list.get(10);
        certno = certno.toLowerCase();
        keepercertno = keepercertno.toLowerCase();
        if (Tools.isCard(certno)) {
          Map tmp_map1 = Tools.getBirthday(certno);
          String tmp_sex1 = (String)tmp_map1.get("sexCode");
          String tmp_birthday1 = (String)tmp_map1.get("birthday");
          if (!birthday1.equals(tmp_birthday1)) {
            tmp_list.set(5, tmp_birthday1);
            warning = "被保人生日错误或格式不对";
          } 
          if (!sex1.equals(tmp_sex1)) {
            tmp_list.set(2, tmp_sex1);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "被保人性别错误或格式不对";
          } 
        } 
        if (Tools.isCard(keepercertno)) {
          Map tmp_map2 = Tools.getBirthday(keepercertno);
          String tmp_sex2 = (String)tmp_map2.get("sexCode");
          String tmp_birthday2 = (String)tmp_map2.get("birthday");
          if (!birthday2.equals(tmp_birthday2)) {
            tmp_list.set(10, tmp_birthday2);
            warning = "投保人生日错误";
          } 
          if (!sex2.equals(tmp_sex2)) {
            tmp_list.set(7, tmp_sex2);
            if (!warning.equals(""))
              warning = String.valueOf(warning) + ", "; 
            warning = "投保人生日性别";
          } 
        } 
        int[] el1 = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };
        if (!Tools.checkExcelEl(tmp_list, el1)) {
          error = "数据不完整";
        } else if (!Tools.isCard(keepercertno)) {
          error = "投保人的证件号无效";
        } else if (!Tools.isCard(certno)) {
          error = "被保人的证件号无效";
        } else if (SysTools.checkBlack(certno, "2")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, "1")) {
          error = "投保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(certno, dins, "被保")) {
          error = "被保人被限制投保(黑名单)";
        } else if (SysTools.checkBlack(keepercertno, dins, "投保")) {
          error = "投保人被限制投保(黑名单)";
        } else if (!Tools.checkAge(keepercertno, 18, 65)) {
          error = "投保人年龄必须 18-65周岁";
        } else if (!Tools.checkAge(certno, 1, 17)) {
          error = "被保人年龄必须 1-17周岁";
        } else if (name.equals(keepername)) {
          error = "被保险人是未成年人，前后的姓名必须不一致";
        } else if (!isCodeNameRepeat(j, keepername, keepercertno, rowList, 6, 9)) {
          error = "被保险人是未成年人，投保人证件号一致，姓名不一致";
        } else if (isValueRepeat(j, certno, rowList, 4)) {
          error = "被保人在一份数据中不允许重复";
        } else if (jdbc.checkSql("select id from data_post_list where flag<>'4' and did=" + did + " and c4='" + certno + "' and post_dt like '" + Tools.getCurrentDate() + "%'")) {
          error = "被保人一天内不允许提交2次";
        } else {
          ArrayList<DataPostListBean> oldList = jdbc.db_select("select id,uid,did,read_dt,post_dt,time1,time2,time3,sn,part,policy_number,policy_begin,policy_end,flag,back_cause,back_part,name,certno,keepername,keepercertno,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,c20,c21,c22,c23,c24,c25,c26,c27,c28,c29,c30,c31,c32,c33,c34,c35,c36,c37,c38,c39,c40,error,warning,pz,mylock from data_post_list where flag<>'4' and (policy_end is null or Date(policy_end)>'" + policy_end + "') and did in (" + "6,7,10,36,37,38" + ") and c4='" + certno + "'", DataPostListBean.class);
          if (oldList.size() > 0) {
            int old_part = 0;
            for (int x = 0; x < oldList.size(); x++) {
              DataPostListBean postx = oldList.get(x);
              old_part += Tools.getIntExcep(postx.getPart());
            } 
            if (old_part >= 2) {
              error = "被保人已达到投保上限(2份)，无法继续投保";
            } else if (old_part == 1 && part.equals("2")) {
              error = "被保人已投保了1份，无法继续投保2份，请选择1份";
            } 
          } 
        } 
        if (!error.equals("数据不完整") && isValueRepeat(j, name, rowList, 1)) {
          if (!warning.equals(""))
            warning = String.valueOf(warning) + ", "; 
          warning = String.valueOf(warning) + "被保人同名: " + name;
        } 
        DataPostListBean bean1 = new DataPostListBean();
        bean1.setId(String.valueOf(j));
        bean1.setUid(this.mb.getId());
        bean1.setDid(did);
        bean1.setPost_dt(post_dt);
        bean1.setSn(sn);
        bean1.setPart(part);
        bean1.setFlag("1");
        bean1.setName(name);
        bean1.setCertno(certno);
        bean1.setKeepername(keepername);
        bean1.setKeepercertno(keepercertno);
        bean1.setError(error);
        bean1.setWarning(warning);
        bean1.setC1(tmp_list.get(1));
        bean1.setC2(tmp_list.get(2));
        bean1.setC3(tmp_list.get(3));
        bean1.setC4(tmp_list.get(4));
        bean1.setC5(tmp_list.get(5));
        bean1.setC6(tmp_list.get(6));
        bean1.setC7(tmp_list.get(7));
        bean1.setC8(tmp_list.get(8));
        bean1.setC9(tmp_list.get(9));
        bean1.setC10(tmp_list.get(10));
        bean1.setC11(tmp_list.get(11));
        post_list.add(bean1);
      } 
      jdbc.closejdbc();
      BigDecimal post_money = Tools.getMultiply(price, String.valueOf(partx), 2);
      back = SysTools.getPostDataTempList(sn, dins, post_list, post_money.compareTo(Tools.getBigDec(this.mb.getMoney())), this.mb);
      DataPostBean post = new DataPostBean();
      post.setUid(this.mb.getId());
      post.setDid(did);
      post.setPost_dt(post_dt);
      post.setPrice(ins_price);
      post.setPost_price(price);
      post.setPost_size(partx);
      post.setPost_number(String.valueOf(post_list.size()));
      post.setPost_money(Tools.getProduct(price, partx, 2));
      post.setPost_file("");
      post.setSn(sn);
      post.setPart(part);
      post.setFlag("1");
      session.setAttribute("current_post", post);
      session.setAttribute("current_post_list", post_list);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return back;
  }
  
  private String trim_all(String str) {
    if (Tools.CheckStr(str)) {
      str = str.trim();
      str = str.replaceAll(" ", "");
      str = str.replaceAll("　", "");
      str = str.replaceAll("\n", "");
      str = str.replaceAll("\t", "");
      return str;
    } 
    return "null";
  }
  
  private boolean isCodeNameRepeat(int index, String name, String code, ArrayList<ArrayList> rowList, int name_index, int code_index) {
    for (int i = 0; i < rowList.size(); i++) {
      ArrayList<String> tmp_list = rowList.get(i);
      String tmp_name = tmp_list.get(name_index);
      String tmp_code = tmp_list.get(code_index);
      if (Tools.CheckStr(tmp_code))
        tmp_code = tmp_code.trim().toLowerCase(); 
      if (index != i && code.equals(tmp_code) && !name.equals(tmp_name))
        return false; 
    } 
    return true;
  }
  
  private boolean isValueRepeat(int sn, String val, ArrayList<ArrayList> rowList, int index) {
    val = val.toLowerCase();
    for (int i = 0; i < rowList.size(); i++) {
      ArrayList<String> tmp_list = rowList.get(i);
      String val1 = tmp_list.get(index);
      if (Tools.CheckStr(val1))
        val1 = val1.trim().toLowerCase(); 
      if (sn != i && val1.equals(val))
        return true; 
    } 
    return false;
  }
  
  private boolean isValueRepeatOld(int sn, String val, ArrayList<ArrayList> rowList, int index) {
    for (int i = 0; i < rowList.size(); i++) {
      ArrayList<String> tmp_list = rowList.get(i);
      String val1 = tmp_list.get(index);
      if (Tools.CheckStr(val1))
        val1 = val1.trim(); 
      if (sn != i && val1.equals(val))
        return true; 
    } 
    return false;
  }
  
  private String getPostDataTempList(String sn, DataInsBean dins, ArrayList<DataPostListBean> list) {
    String back = "";
    ArrayList<E> head = dins.getTableHead();
    ArrayList<E> widths = dins.getTableWidth(dins.getId());
    if (head != null) {
      JSONArray json = new JSONArray();
      JSONArray json_width = new JSONArray();
      for (int i = 0; i < head.size(); i++) {
        try {
          json.put(i, head.get(i).toString());
          json_width.put(i, widths.get(i).toString());
        } catch (Exception e) {
          e.printStackTrace();
        } 
      } 
      JSONArray json_list = new JSONArray();
      for (int j = 0; j < list.size(); j++) {
        DataPostListBean bean1 = list.get(j);
        try {
          json_list.put(j, bean1.getMap());
        } catch (Exception e) {
          e.printStackTrace();
        } 
      } 
      Map<Object, Object> root_map = new HashMap<Object, Object>();
      root_map.put("sn", sn);
      root_map.put("head", json);
      root_map.put("widths", json_width);
      root_map.put("total", Integer.valueOf(json_list.length()));
      root_map.put("rows", json_list);
      return (new JSONObject(root_map)).toString();
    } 
    return back;
  }
  
  private boolean checkBlack(String code, String flag) {
    ArrayList list = flag.equals("1") ? (ArrayList)SysTools.app.getAttribute("sys_data_black1") : (ArrayList)SysTools.app.getAttribute("sys_data_black2");
    for (Object obj1 : list) {
      DataBlackBean dbb = (DataBlackBean)obj1;
      if (code.indexOf(dbb.getCode()) == 0)
        return true; 
    } 
    return false;
  }
  
  private boolean checkBlack(String code, DataInsBean ins, String type) {
    String black = type.equals("投保") ? ins.getBlack1() : ins.getBlack2();
    if (Tools.CheckStr(black)) {
      String[] tmp1 = black.split(",");
      for (int i = 0; i < tmp1.length; i++) {
        String tmp2 = tmp1[i];
        if (code.indexOf(tmp2) == 0)
          return true; 
      } 
    } 
    return false;
  }
  
  public boolean isCarNumber(String carNo) {
    String carnumRegex = "^[京津沪渝冀豫云辽黑湘皖鲁新苏浙赣鄂桂甘晋蒙陕吉闽贵粤青藏川宁琼使领A-Z]{1}[A-Z]{1}[警京津沪渝冀豫云辽黑湘皖鲁新苏浙赣鄂桂甘晋蒙陕吉闽贵粤青藏川宁琼]{0,1}[A-Z0-9]{4}[A-Z0-9挂学警港澳]{1}$";
    if (TextUtils.isEmpty(carNo))
      return false; 
    return carNo.matches(carnumRegex);
  }
  
  public static boolean isLetterDigitOrChinese(String str) {
    String regex = "^[a-z0-9A-Z一-龥_-]+$";
    return str.matches(regex);
  }
  
  public boolean isEngineNumber(String str) {
    String regex = "^[0-9A-Z_-]+$";
    return str.matches(regex);
  }
  
  public boolean isVin(String str) {
    String regex = "^[0-9A-Z]{17}$";
    return str.matches(regex);
  }
  
  public boolean isEmail(String email) {
    if (!Tools.CheckStr(email))
      return false; 
    email = email.trim();
    String regEx1 = "^([a-z0-9A-Z]+[-|\\.]?)+[a-z0-9A-Z]@([a-z0-9A-Z]+(-[a-z0-9A-Z]+)?\\.)+[a-zA-Z]{2,}$";
    Pattern p = Pattern.compile(regEx1);
    Matcher m = p.matcher(email);
    if (m.matches())
      return true; 
    return false;
  }
  
  public boolean isTel(String phone) {
    boolean flag = true;
    String regex = "^((13[0-9])|(14[5,7,9])|(15([0-3]|[5-9]))|(166)|(17[0,1,3,5,6,7,8])|(18[0-9])|(19[8|9]))\\d{8}$";
    if (phone.length() != 11) {
      flag = false;
    } else {
      Pattern p = Pattern.compile(regex);
      Matcher m = p.matcher(phone);
      flag = m.matches();
    } 
    return flag;
  }
  
  public boolean isCard(String idStr) {
    idStr = idStr.toLowerCase();
    String[] wf = { 
        "1", "0", "x", "9", "8", "7", "6", "5", "4", "3", 
        "2" };
    String[] checkCode = { 
        "7", "9", "10", "5", "8", "4", "2", "1", "6", "3", 
        "7", "9", "10", "5", "8", "4", "2" };
    String iDCardNo = "";
    try {
      if (idStr.length() != 15 && idStr.length() != 18)
        return false; 
      if (idStr.length() == 18) {
        iDCardNo = idStr.substring(0, 17);
      } else if (idStr.length() == 15) {
        iDCardNo = String.valueOf(idStr.substring(0, 6)) + "19" + idStr.substring(6, 15);
      } 
      if (!isStrNum(iDCardNo))
        return false; 
      String strYear = iDCardNo.substring(6, 10);
      String strMonth = iDCardNo.substring(10, 12);
      String strDay = iDCardNo.substring(12, 14);
      if (!isStrDate(String.valueOf(strYear) + "-" + strMonth + "-" + strDay))
        return false; 
      GregorianCalendar gc = new GregorianCalendar();
      SimpleDateFormat s = new SimpleDateFormat("yyyy-MM-dd");
      if (gc.get(1) - Integer.parseInt(strYear) > 150 || gc.getTime().getTime() - s.parse(String.valueOf(strYear) + "-" + strMonth + "-" + strDay).getTime() < 0L)
        return false; 
      if (Integer.parseInt(strMonth) > 12 || Integer.parseInt(strMonth) == 0)
        return false; 
      if (Integer.parseInt(strDay) > 31 || Integer.parseInt(strDay) == 0)
        return false; 
      Hashtable h = GetAreaCode();
      if (h.get(iDCardNo.substring(0, 2)) == null)
        return false; 
      int theLastOne = 0;
      for (int i = 0; i < 17; i++)
        theLastOne += Integer.parseInt(String.valueOf(iDCardNo.charAt(i))) * Integer.parseInt(checkCode[i]); 
      int modValue = theLastOne % 11;
      String strVerifyCode = wf[modValue];
      iDCardNo = String.valueOf(iDCardNo) + strVerifyCode;
      if (idStr.length() == 18 && !iDCardNo.equals(idStr))
        return false; 
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return true;
  }
  
  private Hashtable GetAreaCode() {
    Hashtable<Object, Object> hashtable = new Hashtable<Object, Object>();
    hashtable.put("11", "北京");
    hashtable.put("12", "天津");
    hashtable.put("13", "河北");
    hashtable.put("14", "山西");
    hashtable.put("15", "内蒙古");
    hashtable.put("21", "辽宁");
    hashtable.put("22", "吉林");
    hashtable.put("23", "黑龙江");
    hashtable.put("31", "上海");
    hashtable.put("32", "江苏");
    hashtable.put("33", "浙江");
    hashtable.put("34", "安徽");
    hashtable.put("35", "福建");
    hashtable.put("36", "江西");
    hashtable.put("37", "山东");
    hashtable.put("41", "河南");
    hashtable.put("42", "湖北");
    hashtable.put("43", "湖南");
    hashtable.put("44", "广东");
    hashtable.put("45", "广西");
    hashtable.put("46", "海南");
    hashtable.put("50", "重庆");
    hashtable.put("51", "四川");
    hashtable.put("52", "贵州");
    hashtable.put("53", "云南");
    hashtable.put("54", "西藏");
    hashtable.put("61", "陕西");
    hashtable.put("62", "甘肃");
    hashtable.put("63", "青海");
    hashtable.put("64", "宁夏");
    hashtable.put("65", "新疆");
    hashtable.put("71", "台湾");
    hashtable.put("81", "香港");
    hashtable.put("82", "澳门");
    hashtable.put("91", "国外");
    return hashtable;
  }
  
  private boolean isStrNum(String str) {
    Pattern pattern = Pattern.compile("[0-9]*");
    Matcher isNum = pattern.matcher(str);
    if (isNum.matches())
      return true; 
    return false;
  }
  
  public boolean isStrDate(String strDate) {
    Pattern pattern = Pattern.compile("^((\\d{2}(([02468][048])|([13579][26]))[\\-\\/\\s]?((((0?[13578])|(1[02]))[\\-\\/\\s]?((0?[1-9])|([1-2][0-9])|(3[01])))|(((0?[469])|(11))[\\-\\/\\s]?((0?[1-9])|([1-2][0-9])|(30)))|(0?2[\\-\\/\\s]?((0?[1-9])|([1-2][0-9])))))|(\\d{2}(([02468][1235679])|([13579][01345789]))[\\-\\/\\s]?((((0?[13578])|(1[02]))[\\-\\/\\s]?((0?[1-9])|([1-2][0-9])|(3[01])))|(((0?[469])|(11))[\\-\\/\\s]?((0?[1-9])|([1-2][0-9])|(30)))|(0?2[\\-\\/\\s]?((0?[1-9])|(1[0-9])|(2[0-8]))))))(\\s(((0?[0-9])|([1-2][0-3]))\\:([0-5]?[0-9])((\\s)|(\\:([0-5]?[0-9])))))?$");
    Matcher m = pattern.matcher(strDate);
    if (m.matches())
      return true; 
    return false;
  }
  
  public String getLimitStr(String str) {
    String back = "";
    if (str.indexOf("m") > -1) {
      back = String.valueOf(str.replaceFirst("m", "")) + "月";
    } else if (str.indexOf("d") > -1) {
      back = String.valueOf(str.replaceFirst("d", "")) + "天";
    } else {
      back = String.valueOf(str) + "岁";
    } 
    return back;
  }
  
  public boolean checkAge(String certificateNo, String cert_min, String cert_max) {
    int age = getAge(certificateNo);
    if (cert_min.indexOf("m") > -1) {
      int selectYear = Integer.valueOf(certificateNo.substring(6, 10)).intValue();
      int selectMonth = Integer.valueOf(certificateNo.substring(10, 12)).intValue();
      int now_year = Calendar.getInstance().get(1);
      int now_month = Calendar.getInstance().get(2) + 1;
      int m1 = selectYear * 12 + selectMonth;
      int m2 = now_year * 12 + now_month;
      int m3 = m2 - m1;
      int min = Tools.getIntExcep(cert_min.replaceFirst("m", ""));
      int max = Integer.valueOf(cert_max).intValue();
      if (m3 >= min && age <= max)
        return true; 
    } else if (cert_min.indexOf("d") > -1) {
      String y = certificateNo.substring(6, 10);
      String m = certificateNo.substring(10, 12);
      String d = certificateNo.substring(12, 14);
      long days = Tools.getDays(String.valueOf(y) + "-" + m + "-" + d, Tools.getCurrentDate());
      int min = Integer.valueOf(cert_min.replaceFirst("d", "")).intValue();
      int max = Integer.valueOf(cert_max).intValue();
      if (days >= min && age <= max)
        return true; 
    } else {
      int min = Integer.valueOf(cert_min).intValue();
      int max = Integer.valueOf(cert_max).intValue();
      if (age >= min && age <= max)
        return true; 
    } 
    return false;
  }
  
  public int getAge(String certno) {
    int selectYear = Integer.valueOf(certno.substring(6, 10)).intValue();
    int selectMonth = Integer.valueOf(certno.substring(10, 12)).intValue();
    int selectDay = Integer.valueOf(certno.substring(12, 14)).intValue();
    Calendar cal = Calendar.getInstance();
    int yearNow = cal.get(1);
    int monthNow = cal.get(2) + 1;
    int dayNow = cal.get(5);
    int yearMinus = yearNow - selectYear - 1;
    int monthMinus = monthNow - selectMonth;
    int dayMinus = dayNow - selectDay;
    int age = yearMinus;
    if (yearMinus < 0) {
      age = 0;
    } else if (yearMinus == 0) {
      if (monthMinus < 0) {
        age = 0;
      } else if (monthMinus == 0) {
        if (dayMinus < 0) {
          age = 0;
        } else if (dayMinus >= 0) {
          age = 1;
        } 
      } else if (monthMinus > 0) {
        age = 1;
      } 
    } else if (yearMinus > 0 && 
      monthMinus >= 0) {
      if (monthMinus == 0) {
        if (dayMinus >= 0 && 
          dayMinus >= 0)
          age++; 
      } else if (monthMinus > 0) {
        age++;
      } 
    } 
    return age;
  }
}
